#ifndef SBK_ACTIONWRAPPER_H
#define SBK_ACTIONWRAPPER_H

#include <enhancedmenu.h>


// Extra includes
#include <qobject.h>
#include <qicon.h>
#include <qkeysequence.h>
#include <qwidget.h>
#include <qcoreevent.h>
#include <QList>
#include <qmenu.h>
#include <qobjectdefs.h>
#include <qactiongroup.h>
#include <qfont.h>
namespace PySide { class DynamicQMetaObject; }

class ActionWrapper : public Action
{
public:
    ActionWrapper(QObject * parent = nullptr);
    ActionWrapper(const QIcon & icon, const QString & text, QObject * parent = nullptr);
    ActionWrapper(const QString & text, QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { Action::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { Action::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { Action::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { Action::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline bool event_protected(QEvent * arg__1) { return Action::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline void timerEvent_protected(QTimerEvent * event) { Action::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~ActionWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  ifndef SBK_QACTIONWRAPPER_H
#  define SBK_QACTIONWRAPPER_H

// Inherited base class:
class QActionWrapper : public QAction
{
public:
    QActionWrapper(QObject * parent = nullptr);
    QActionWrapper(const QIcon & icon, const QString & text, QObject * parent = nullptr);
    QActionWrapper(const QString & text, QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QAction::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QAction::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QAction::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QAction::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline bool event_protected(QEvent * arg__1) { return QAction::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QAction::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QAction::receivers(signal); }
    inline QObject * sender_protected() const { return QAction::sender(); }
    inline int senderSignalIndex_protected() const { return QAction::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QAction::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QActionWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QACTIONWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_ACTIONWRAPPER_H

