#ifndef SBK_COOKIEJARWRAPPER_H
#define SBK_COOKIEJARWRAPPER_H

#include <cookiejar.h>


// Extra includes
#include <qobject.h>
#include <qnetworkcookie.h>
#include <QVector>
#include <qurl.h>
#include <qbytearray.h>
#include <qcoreevent.h>
#include <qobjectdefs.h>
#include <QList>
namespace PySide { class DynamicQMetaObject; }

class CookieJarWrapper : public CookieJar
{
public:
    CookieJarWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { CookieJar::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { CookieJar::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { CookieJar::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { CookieJar::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return CookieJar::isSignalConnected(signal); }
    inline bool listMatchesDomain_protected(const QStringList & list, const QString & cookieDomain) const { return CookieJar::listMatchesDomain(list, cookieDomain); }
    inline bool matchDomain_protected(QString cookieDomain, QString siteDomain) const { return CookieJar::matchDomain(cookieDomain, siteDomain); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return CookieJar::receivers(signal); }
    inline QObject * sender_protected() const { return CookieJar::sender(); }
    inline int senderSignalIndex_protected() const { return CookieJar::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { CookieJar::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~CookieJarWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_COOKIEJARWRAPPER_H

