#ifndef SBK_DELAYEDFILEWATCHERWRAPPER_H
#define SBK_DELAYEDFILEWATCHERWRAPPER_H

#include <delayedfilewatcher.h>


// Extra includes
#include <qobject.h>
#include <qcoreevent.h>
#include <qobjectdefs.h>
namespace PySide { class DynamicQMetaObject; }

class DelayedFileWatcherWrapper : public DelayedFileWatcher
{
public:
    DelayedFileWatcherWrapper(QObject * parent = nullptr);
    DelayedFileWatcherWrapper(const QStringList & paths, QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { DelayedFileWatcher::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { DelayedFileWatcher::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { DelayedFileWatcher::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { DelayedFileWatcher::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline void timerEvent_protected(QTimerEvent * event) { DelayedFileWatcher::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~DelayedFileWatcherWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  ifndef SBK_QFILESYSTEMWATCHERWRAPPER_H
#  define SBK_QFILESYSTEMWATCHERWRAPPER_H

// Inherited base class:
class QFileSystemWatcherWrapper : public QFileSystemWatcher
{
public:
    QFileSystemWatcherWrapper(QObject * parent = nullptr);
    QFileSystemWatcherWrapper(const QStringList & paths, QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QFileSystemWatcher::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QFileSystemWatcher::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QFileSystemWatcher::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QFileSystemWatcher::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QFileSystemWatcher::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QFileSystemWatcher::receivers(signal); }
    inline QObject * sender_protected() const { return QFileSystemWatcher::sender(); }
    inline int senderSignalIndex_protected() const { return QFileSystemWatcher::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QFileSystemWatcher::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QFileSystemWatcherWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QFILESYSTEMWATCHERWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_DELAYEDFILEWATCHERWRAPPER_H

