#ifndef SBK_HISTORYMODELWRAPPER_H
#define SBK_HISTORYMODELWRAPPER_H

#include <historymodel.h>


// Extra includes
#include <qobject.h>
#include <history.h>
#include <qabstractitemmodel.h>
#include <historyitem.h>
#include <QList>
#include <qcoreevent.h>
#include <qmimedata.h>
#include <qdatastream.h>
#include <QMap>
#include <QVector>
#include <pysideqflags.h>
#include <qbytearray.h>
#include <qobjectdefs.h>
#include <qsize.h>
namespace PySide { class DynamicQMetaObject; }

class HistoryModelWrapper : public HistoryModel
{
public:
    HistoryModelWrapper(History * history);
    inline void beginInsertColumns_protected(const QModelIndex & parent, int first, int last) { HistoryModel::beginInsertColumns(parent, first, last); }
    inline void beginInsertRows_protected(const QModelIndex & parent, int first, int last) { HistoryModel::beginInsertRows(parent, first, last); }
    inline bool beginMoveColumns_protected(const QModelIndex & sourceParent, int sourceFirst, int sourceLast, const QModelIndex & destinationParent, int destinationColumn) { return HistoryModel::beginMoveColumns(sourceParent, sourceFirst, sourceLast, destinationParent, destinationColumn); }
    inline bool beginMoveRows_protected(const QModelIndex & sourceParent, int sourceFirst, int sourceLast, const QModelIndex & destinationParent, int destinationRow) { return HistoryModel::beginMoveRows(sourceParent, sourceFirst, sourceLast, destinationParent, destinationRow); }
    inline void beginRemoveColumns_protected(const QModelIndex & parent, int first, int last) { HistoryModel::beginRemoveColumns(parent, first, last); }
    inline void beginRemoveRows_protected(const QModelIndex & parent, int first, int last) { HistoryModel::beginRemoveRows(parent, first, last); }
    inline void beginResetModel_protected() { HistoryModel::beginResetModel(); }
    QModelIndex buddy(const QModelIndex & index) const override;
    bool canDropMimeData(const QMimeData * data, Qt::DropAction action, int row, int column, const QModelIndex & parent) const override;
    bool canFetchMore(const QModelIndex & parent) const override;
    inline void changePersistentIndex_protected(const QModelIndex & from, const QModelIndex & to) { HistoryModel::changePersistentIndex(from, to); }
    inline void changePersistentIndexList_protected(const QModelIndexList & from, const QModelIndexList & to) { HistoryModel::changePersistentIndexList(from, to); }
    inline void childEvent_protected(QChildEvent * event) { HistoryModel::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    int columnCount(const QModelIndex & parent = QModelIndex()) const override;
    inline void connectNotify_protected(const QMetaMethod & signal) { HistoryModel::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline QModelIndex createIndex_protected(int row, int column, quintptr id) const { return HistoryModel::createIndex(row, column, id); }
    inline void customEvent_protected(QEvent * event) { HistoryModel::customEvent(event); }
    void customEvent(QEvent * event) override;
    QVariant data(const QModelIndex & index, int role) const override;
    inline bool decodeData_protected(int row, int column, const QModelIndex & parent, QDataStream & stream) { return HistoryModel::decodeData(row, column, parent, stream); }
    inline void disconnectNotify_protected(const QMetaMethod & signal) { HistoryModel::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool dropMimeData(const QMimeData * data, Qt::DropAction action, int row, int column, const QModelIndex & parent) override;
    inline void encodeData_protected(const QModelIndexList & indexes, QDataStream & stream) const { HistoryModel::encodeData(indexes, stream); }
    inline void endInsertColumns_protected() { HistoryModel::endInsertColumns(); }
    inline void endInsertRows_protected() { HistoryModel::endInsertRows(); }
    inline void endMoveColumns_protected() { HistoryModel::endMoveColumns(); }
    inline void endMoveRows_protected() { HistoryModel::endMoveRows(); }
    inline void endRemoveColumns_protected() { HistoryModel::endRemoveColumns(); }
    inline void endRemoveRows_protected() { HistoryModel::endRemoveRows(); }
    inline void endResetModel_protected() { HistoryModel::endResetModel(); }
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    void fetchMore(const QModelIndex & parent) override;
    QFlags<Qt::ItemFlag> flags(const QModelIndex & index) const override;
    bool hasChildren(const QModelIndex & parent) const override;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
    QModelIndex index(int row, int column, const QModelIndex & parent = QModelIndex()) const override;
    bool insertColumns(int column, int count, const QModelIndex & parent = QModelIndex()) override;
    bool insertRows(int row, int count, const QModelIndex & parent = QModelIndex()) override;
    QMap<int,QVariant > itemData(const QModelIndex & index) const override;
    QModelIndexList match(const QModelIndex & start, int role, const QVariant & value, int hits = 1, QFlags<Qt::MatchFlag> flags = Qt::MatchFlags(Qt::MatchStartsWith|Qt::MatchWrap)) const override;
    const QMetaObject * metaObject() const override;
    QMimeData * mimeData(const QModelIndexList & indexes) const override;
    QStringList mimeTypes() const override;
    bool moveColumns(const QModelIndex & sourceParent, int sourceColumn, int count, const QModelIndex & destinationParent, int destinationChild) override;
    bool moveRows(const QModelIndex & sourceParent, int sourceRow, int count, const QModelIndex & destinationParent, int destinationChild) override;
    QModelIndex parent(const QModelIndex & child) const override;
    inline QModelIndexList persistentIndexList_protected() const { return HistoryModel::persistentIndexList(); }
    bool removeColumns(int column, int count, const QModelIndex & parent = QModelIndex()) override;
    bool removeRows(int row, int count, const QModelIndex & parent = QModelIndex()) override;
    inline void resetInternalData_protected() { HistoryModel::resetInternalData(); }
    void revert() override;
    QHash<int,QByteArray > roleNames() const override;
    int rowCount(const QModelIndex & parent = QModelIndex()) const override;
    bool setData(const QModelIndex & index, const QVariant & value, int role) override;
    bool setHeaderData(int section, Qt::Orientation orientation, const QVariant & value, int role = Qt::EditRole) override;
    bool setItemData(const QModelIndex & index, const QMap<int,QVariant > & roles) override;
    QModelIndex sibling(int row, int column, const QModelIndex & idx) const override;
    void sort(int column, Qt::SortOrder order = Qt::AscendingOrder) override;
    QSize span(const QModelIndex & index) const override;
    bool submit() override;
    QFlags<Qt::DropAction> supportedDragActions() const override;
    QFlags<Qt::DropAction> supportedDropActions() const override;
    inline void timerEvent_protected(QTimerEvent * event) { HistoryModel::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~HistoryModelWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[42];
};

#  ifndef SBK_QABSTRACTITEMMODELWRAPPER_H
#  define SBK_QABSTRACTITEMMODELWRAPPER_H

// Inherited base class:
class QAbstractItemModelWrapper : public QAbstractItemModel
{
public:
    QAbstractItemModelWrapper(QObject * parent = nullptr);
    inline void beginInsertColumns_protected(const QModelIndex & parent, int first, int last) { QAbstractItemModel::beginInsertColumns(parent, first, last); }
    inline void beginInsertRows_protected(const QModelIndex & parent, int first, int last) { QAbstractItemModel::beginInsertRows(parent, first, last); }
    inline bool beginMoveColumns_protected(const QModelIndex & sourceParent, int sourceFirst, int sourceLast, const QModelIndex & destinationParent, int destinationColumn) { return QAbstractItemModel::beginMoveColumns(sourceParent, sourceFirst, sourceLast, destinationParent, destinationColumn); }
    inline bool beginMoveRows_protected(const QModelIndex & sourceParent, int sourceFirst, int sourceLast, const QModelIndex & destinationParent, int destinationRow) { return QAbstractItemModel::beginMoveRows(sourceParent, sourceFirst, sourceLast, destinationParent, destinationRow); }
    inline void beginRemoveColumns_protected(const QModelIndex & parent, int first, int last) { QAbstractItemModel::beginRemoveColumns(parent, first, last); }
    inline void beginRemoveRows_protected(const QModelIndex & parent, int first, int last) { QAbstractItemModel::beginRemoveRows(parent, first, last); }
    inline void beginResetModel_protected() { QAbstractItemModel::beginResetModel(); }
    QModelIndex buddy(const QModelIndex & index) const override;
    bool canDropMimeData(const QMimeData * data, Qt::DropAction action, int row, int column, const QModelIndex & parent) const override;
    bool canFetchMore(const QModelIndex & parent) const override;
    inline void changePersistentIndex_protected(const QModelIndex & from, const QModelIndex & to) { QAbstractItemModel::changePersistentIndex(from, to); }
    inline void changePersistentIndexList_protected(const QModelIndexList & from, const QModelIndexList & to) { QAbstractItemModel::changePersistentIndexList(from, to); }
    inline void childEvent_protected(QChildEvent * event) { QAbstractItemModel::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    int columnCount(const QModelIndex & parent = QModelIndex()) const override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QAbstractItemModel::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline QModelIndex createIndex_protected(int row, int column, quintptr id) const { return QAbstractItemModel::createIndex(row, column, id); }
    inline QModelIndex createIndex_protected(int row, int column, void * data = nullptr) const { return QAbstractItemModel::createIndex(row, column, data); }
    inline void customEvent_protected(QEvent * event) { QAbstractItemModel::customEvent(event); }
    void customEvent(QEvent * event) override;
    QVariant data(const QModelIndex & index, int role = Qt::DisplayRole) const override;
    inline bool decodeData_protected(int row, int column, const QModelIndex & parent, QDataStream & stream) { return QAbstractItemModel::decodeData(row, column, parent, stream); }
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QAbstractItemModel::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool dropMimeData(const QMimeData * data, Qt::DropAction action, int row, int column, const QModelIndex & parent) override;
    inline void encodeData_protected(const QModelIndexList & indexes, QDataStream & stream) const { QAbstractItemModel::encodeData(indexes, stream); }
    inline void endInsertColumns_protected() { QAbstractItemModel::endInsertColumns(); }
    inline void endInsertRows_protected() { QAbstractItemModel::endInsertRows(); }
    inline void endMoveColumns_protected() { QAbstractItemModel::endMoveColumns(); }
    inline void endMoveRows_protected() { QAbstractItemModel::endMoveRows(); }
    inline void endRemoveColumns_protected() { QAbstractItemModel::endRemoveColumns(); }
    inline void endRemoveRows_protected() { QAbstractItemModel::endRemoveRows(); }
    inline void endResetModel_protected() { QAbstractItemModel::endResetModel(); }
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    void fetchMore(const QModelIndex & parent) override;
    QFlags<Qt::ItemFlag> flags(const QModelIndex & index) const override;
    bool hasChildren(const QModelIndex & parent = QModelIndex()) const override;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
    QModelIndex index(int row, int column, const QModelIndex & parent = QModelIndex()) const override;
    bool insertColumns(int column, int count, const QModelIndex & parent = QModelIndex()) override;
    bool insertRows(int row, int count, const QModelIndex & parent = QModelIndex()) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QAbstractItemModel::isSignalConnected(signal); }
    QMap<int,QVariant > itemData(const QModelIndex & index) const override;
    QModelIndexList match(const QModelIndex & start, int role, const QVariant & value, int hits = 1, QFlags<Qt::MatchFlag> flags = Qt::MatchFlags(Qt::MatchStartsWith|Qt::MatchWrap)) const override;
    const QMetaObject * metaObject() const override;
    QMimeData * mimeData(const QModelIndexList & indexes) const override;
    QStringList mimeTypes() const override;
    bool moveColumns(const QModelIndex & sourceParent, int sourceColumn, int count, const QModelIndex & destinationParent, int destinationChild) override;
    bool moveRows(const QModelIndex & sourceParent, int sourceRow, int count, const QModelIndex & destinationParent, int destinationChild) override;
    QModelIndex parent(const QModelIndex & child) const override;
    inline QModelIndexList persistentIndexList_protected() const { return QAbstractItemModel::persistentIndexList(); }
    inline int receivers_protected(const char * signal) const { return QAbstractItemModel::receivers(signal); }
    bool removeColumns(int column, int count, const QModelIndex & parent = QModelIndex()) override;
    bool removeRows(int row, int count, const QModelIndex & parent = QModelIndex()) override;
    inline void resetInternalData_protected() { QAbstractItemModel::resetInternalData(); }
    void revert() override;
    QHash<int,QByteArray > roleNames() const override;
    int rowCount(const QModelIndex & parent = QModelIndex()) const override;
    inline QObject * sender_protected() const { return QAbstractItemModel::sender(); }
    inline int senderSignalIndex_protected() const { return QAbstractItemModel::senderSignalIndex(); }
    bool setData(const QModelIndex & index, const QVariant & value, int role = Qt::EditRole) override;
    bool setHeaderData(int section, Qt::Orientation orientation, const QVariant & value, int role = Qt::EditRole) override;
    bool setItemData(const QModelIndex & index, const QMap<int,QVariant > & roles) override;
    QModelIndex sibling(int row, int column, const QModelIndex & idx) const override;
    void sort(int column, Qt::SortOrder order = Qt::AscendingOrder) override;
    QSize span(const QModelIndex & index) const override;
    bool submit() override;
    QFlags<Qt::DropAction> supportedDragActions() const override;
    QFlags<Qt::DropAction> supportedDropActions() const override;
    inline void timerEvent_protected(QTimerEvent * event) { QAbstractItemModel::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QAbstractItemModelWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[42];
};

#  endif // SBK_QABSTRACTITEMMODELWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_HISTORYMODELWRAPPER_H

