#ifndef SBK_LOCATIONBARWRAPPER_H
#define SBK_LOCATIONBARWRAPPER_H

#include <locationbar.h>


// Extra includes
#include <qobject.h>
#include <qwidget.h>
#include <browserwindow.h>
#include <tabbedwebview.h>
#include <qurl.h>
#include <searchenginesmanager.h>
#include <locationbar.h>
#include <loadrequest.h>
#include <qevent.h>
#include <qmenu.h>
#include <qcoreevent.h>
#include <qpainter.h>
#include <qpaintdevice.h>
#include <qpoint.h>
#include <qsize.h>
#include <qaction.h>
#include <qbytearray.h>
#include <QList>
#include <QTextLayout>
#include <qobjectdefs.h>
namespace PySide { class DynamicQMetaObject; }

class LocationBarWrapper : public LocationBar
{
public:
    LocationBarWrapper(QWidget * parent = nullptr);
    inline void actionEvent_protected(QActionEvent * event) { LocationBar::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void changeEvent_protected(QEvent * arg__1) { LocationBar::changeEvent(arg__1); }
    void changeEvent(QEvent * arg__1) override;
    inline void childEvent_protected(QChildEvent * event) { LocationBar::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { LocationBar::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { LocationBar::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline QMenu * createContextMenu_protected() { return LocationBar::createContextMenu(); }
    inline void customEvent_protected(QEvent * event) { LocationBar::customEvent(event); }
    void customEvent(QEvent * event) override;
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { LocationBar::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * arg__1) { LocationBar::dragEnterEvent(arg__1); }
    void dragEnterEvent(QDragEnterEvent * arg__1) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * e) { LocationBar::dragLeaveEvent(e); }
    void dragLeaveEvent(QDragLeaveEvent * e) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * e) { LocationBar::dragMoveEvent(e); }
    void dragMoveEvent(QDragMoveEvent * e) override;
    inline void enterEvent_protected(QEvent * event) { LocationBar::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * event) { return LocationBar::event(event); }
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool focusNextPrevChild_protected(bool next) { return LocationBar::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { LocationBar::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline void initPainter_protected(QPainter * painter) const { LocationBar::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void inputMethodEvent_protected(QInputMethodEvent * arg__1) { LocationBar::inputMethodEvent(arg__1); }
    void inputMethodEvent(QInputMethodEvent * arg__1) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { LocationBar::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { LocationBar::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return LocationBar::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { LocationBar::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * arg__1) { LocationBar::mouseMoveEvent(arg__1); }
    void mouseMoveEvent(QMouseEvent * arg__1) override;
    inline void mousePressEvent_protected(QMouseEvent * event) { LocationBar::mousePressEvent(event); }
    void mousePressEvent(QMouseEvent * event) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * event) { LocationBar::mouseReleaseEvent(event); }
    void mouseReleaseEvent(QMouseEvent * event) override;
    inline void moveEvent_protected(QMoveEvent * event) { LocationBar::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return LocationBar::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    QPaintEngine * paintEngine() const override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return LocationBar::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { LocationBar::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return LocationBar::sharedPainter(); }
    QPainter * sharedPainter() const override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { LocationBar::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { LocationBar::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void wheelEvent_protected(QWheelEvent * event) { LocationBar::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~LocationBarWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[48];
};

#  ifndef SBK_LINEEDITWRAPPER_H
#  define SBK_LINEEDITWRAPPER_H

// Inherited base class:
class LineEditWrapper : public LineEdit
{
public:
    LineEditWrapper(QWidget * parent = nullptr);
    inline void actionEvent_protected(QActionEvent * event) { LineEdit::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void changeEvent_protected(QEvent * arg__1) { LineEdit::changeEvent(arg__1); }
    void changeEvent(QEvent * arg__1) override;
    inline void childEvent_protected(QChildEvent * event) { LineEdit::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { LineEdit::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { LineEdit::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * arg__1) { LineEdit::contextMenuEvent(arg__1); }
    void contextMenuEvent(QContextMenuEvent * arg__1) override;
    inline QMenu * createContextMenu_protected() { return LineEdit::createContextMenu(); }
    inline QRect cursorRect_protected() const { return LineEdit::cursorRect(); }
    inline void customEvent_protected(QEvent * event) { LineEdit::customEvent(event); }
    void customEvent(QEvent * event) override;
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { LineEdit::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * arg__1) { LineEdit::dragEnterEvent(arg__1); }
    void dragEnterEvent(QDragEnterEvent * arg__1) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * e) { LineEdit::dragLeaveEvent(e); }
    void dragLeaveEvent(QDragLeaveEvent * e) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * e) { LineEdit::dragMoveEvent(e); }
    void dragMoveEvent(QDragMoveEvent * e) override;
    inline void dropEvent_protected(QDropEvent * arg__1) { LineEdit::dropEvent(arg__1); }
    void dropEvent(QDropEvent * arg__1) override;
    inline void enterEvent_protected(QEvent * event) { LineEdit::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * event) { return LineEdit::event(event); }
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * event) { LineEdit::focusInEvent(event); }
    void focusInEvent(QFocusEvent * event) override;
    inline bool focusNextPrevChild_protected(bool next) { return LineEdit::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * arg__1) { LineEdit::focusOutEvent(arg__1); }
    void focusOutEvent(QFocusEvent * arg__1) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { LineEdit::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline void initPainter_protected(QPainter * painter) const { LineEdit::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void initStyleOption_protected(QStyleOptionFrame * option) const { LineEdit::initStyleOption(option); }
    inline void inputMethodEvent_protected(QInputMethodEvent * arg__1) { LineEdit::inputMethodEvent(arg__1); }
    void inputMethodEvent(QInputMethodEvent * arg__1) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline void keyPressEvent_protected(QKeyEvent * arg__1) { LineEdit::keyPressEvent(arg__1); }
    void keyPressEvent(QKeyEvent * arg__1) override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { LineEdit::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { LineEdit::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return LineEdit::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { LineEdit::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * arg__1) { LineEdit::mouseMoveEvent(arg__1); }
    void mouseMoveEvent(QMouseEvent * arg__1) override;
    inline void mousePressEvent_protected(QMouseEvent * event) { LineEdit::mousePressEvent(event); }
    void mousePressEvent(QMouseEvent * event) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * event) { LineEdit::mouseReleaseEvent(event); }
    void mouseReleaseEvent(QMouseEvent * event) override;
    inline void moveEvent_protected(QMoveEvent * event) { LineEdit::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return LineEdit::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * arg__1) { LineEdit::paintEvent(arg__1); }
    void paintEvent(QPaintEvent * arg__1) override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return LineEdit::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { LineEdit::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return LineEdit::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { LineEdit::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { LineEdit::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { LineEdit::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void wheelEvent_protected(QWheelEvent * event) { LineEdit::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~LineEditWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    inline QVariant inputMethodQuery(Qt::InputMethodQuery property, QVariant argument) const { return LineEdit::inputMethodQuery(Qt::InputMethodQuery(property), argument); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[48];
};

#  endif // SBK_LINEEDITWRAPPER_H

#  ifndef SBK_QLINEEDITWRAPPER_H
#  define SBK_QLINEEDITWRAPPER_H

// Inherited base class:
class QLineEditWrapper : public QLineEdit
{
public:
    QLineEditWrapper(QWidget * parent = nullptr);
    QLineEditWrapper(const QString & arg__1, QWidget * parent = nullptr);
    inline void actionEvent_protected(QActionEvent * event) { QLineEdit::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void changeEvent_protected(QEvent * arg__1) { QLineEdit::changeEvent(arg__1); }
    void changeEvent(QEvent * arg__1) override;
    inline void childEvent_protected(QChildEvent * event) { QLineEdit::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { QLineEdit::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QLineEdit::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * arg__1) { QLineEdit::contextMenuEvent(arg__1); }
    void contextMenuEvent(QContextMenuEvent * arg__1) override;
    inline void create_protected(WId arg__1 = 0, bool initializeWindow = true, bool destroyOldWindow = true) { QLineEdit::create(arg__1, initializeWindow, destroyOldWindow); }
    inline QRect cursorRect_protected() const { return QLineEdit::cursorRect(); }
    inline void customEvent_protected(QEvent * event) { QLineEdit::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void destroy_protected(bool destroyWindow = true, bool destroySubWindows = true) { QLineEdit::destroy(destroyWindow, destroySubWindows); }
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QLineEdit::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * arg__1) { QLineEdit::dragEnterEvent(arg__1); }
    void dragEnterEvent(QDragEnterEvent * arg__1) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * e) { QLineEdit::dragLeaveEvent(e); }
    void dragLeaveEvent(QDragLeaveEvent * e) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * e) { QLineEdit::dragMoveEvent(e); }
    void dragMoveEvent(QDragMoveEvent * e) override;
    inline void dropEvent_protected(QDropEvent * arg__1) { QLineEdit::dropEvent(arg__1); }
    void dropEvent(QDropEvent * arg__1) override;
    inline void enterEvent_protected(QEvent * event) { QLineEdit::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * arg__1) { QLineEdit::focusInEvent(arg__1); }
    void focusInEvent(QFocusEvent * arg__1) override;
    inline bool focusNextChild_protected() { return QLineEdit::focusNextChild(); }
    inline bool focusNextPrevChild_protected(bool next) { return QLineEdit::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * arg__1) { QLineEdit::focusOutEvent(arg__1); }
    void focusOutEvent(QFocusEvent * arg__1) override;
    inline bool focusPreviousChild_protected() { return QLineEdit::focusPreviousChild(); }
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { QLineEdit::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline void initPainter_protected(QPainter * painter) const { QLineEdit::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void initStyleOption_protected(QStyleOptionFrame * option) const { QLineEdit::initStyleOption(option); }
    inline void inputMethodEvent_protected(QInputMethodEvent * arg__1) { QLineEdit::inputMethodEvent(arg__1); }
    void inputMethodEvent(QInputMethodEvent * arg__1) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline void keyPressEvent_protected(QKeyEvent * arg__1) { QLineEdit::keyPressEvent(arg__1); }
    void keyPressEvent(QKeyEvent * arg__1) override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { QLineEdit::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { QLineEdit::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return QLineEdit::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * arg__1) { QLineEdit::mouseDoubleClickEvent(arg__1); }
    void mouseDoubleClickEvent(QMouseEvent * arg__1) override;
    inline void mouseMoveEvent_protected(QMouseEvent * arg__1) { QLineEdit::mouseMoveEvent(arg__1); }
    void mouseMoveEvent(QMouseEvent * arg__1) override;
    inline void mousePressEvent_protected(QMouseEvent * arg__1) { QLineEdit::mousePressEvent(arg__1); }
    void mousePressEvent(QMouseEvent * arg__1) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * arg__1) { QLineEdit::mouseReleaseEvent(arg__1); }
    void mouseReleaseEvent(QMouseEvent * arg__1) override;
    inline void moveEvent_protected(QMoveEvent * event) { QLineEdit::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return QLineEdit::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * arg__1) { QLineEdit::paintEvent(arg__1); }
    void paintEvent(QPaintEvent * arg__1) override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return QLineEdit::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { QLineEdit::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return QLineEdit::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { QLineEdit::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { QLineEdit::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { QLineEdit::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void updateMicroFocus_protected() { QLineEdit::updateMicroFocus(); }
    inline void wheelEvent_protected(QWheelEvent * event) { QLineEdit::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~QLineEditWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    // Inherited overloads, because the using keyword sux
    inline QVariant inputMethodQuery(Qt::InputMethodQuery property, QVariant argument) const { return QLineEdit::inputMethodQuery(Qt::InputMethodQuery(property), argument); }
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[48];
};

#  endif // SBK_QLINEEDITWRAPPER_H

#  ifndef SBK_QWIDGETWRAPPER_H
#  define SBK_QWIDGETWRAPPER_H

// Inherited base class:
class QWidgetWrapper : public QWidget
{
public:
    QWidgetWrapper(QWidget * parent = nullptr, QFlags<Qt::WindowType> f = Qt::WindowFlags());
    inline void actionEvent_protected(QActionEvent * event) { QWidget::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void changeEvent_protected(QEvent * event) { QWidget::changeEvent(event); }
    void changeEvent(QEvent * event) override;
    inline void childEvent_protected(QChildEvent * event) { QWidget::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { QWidget::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QWidget::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * event) { QWidget::contextMenuEvent(event); }
    void contextMenuEvent(QContextMenuEvent * event) override;
    inline void create_protected(WId arg__1 = 0, bool initializeWindow = true, bool destroyOldWindow = true) { QWidget::create(arg__1, initializeWindow, destroyOldWindow); }
    inline void customEvent_protected(QEvent * event) { QWidget::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void destroy_protected(bool destroyWindow = true, bool destroySubWindows = true) { QWidget::destroy(destroyWindow, destroySubWindows); }
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QWidget::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * event) { QWidget::dragEnterEvent(event); }
    void dragEnterEvent(QDragEnterEvent * event) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * event) { QWidget::dragLeaveEvent(event); }
    void dragLeaveEvent(QDragLeaveEvent * event) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * event) { QWidget::dragMoveEvent(event); }
    void dragMoveEvent(QDragMoveEvent * event) override;
    inline void dropEvent_protected(QDropEvent * event) { QWidget::dropEvent(event); }
    void dropEvent(QDropEvent * event) override;
    inline void enterEvent_protected(QEvent * event) { QWidget::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * event) { return QWidget::event(event); }
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * event) { QWidget::focusInEvent(event); }
    void focusInEvent(QFocusEvent * event) override;
    inline bool focusNextChild_protected() { return QWidget::focusNextChild(); }
    inline bool focusNextPrevChild_protected(bool next) { return QWidget::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * event) { QWidget::focusOutEvent(event); }
    void focusOutEvent(QFocusEvent * event) override;
    inline bool focusPreviousChild_protected() { return QWidget::focusPreviousChild(); }
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { QWidget::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline void initPainter_protected(QPainter * painter) const { QWidget::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { QWidget::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QWidget::isSignalConnected(signal); }
    inline void keyPressEvent_protected(QKeyEvent * event) { QWidget::keyPressEvent(event); }
    void keyPressEvent(QKeyEvent * event) override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { QWidget::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { QWidget::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return QWidget::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { QWidget::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * event) { QWidget::mouseMoveEvent(event); }
    void mouseMoveEvent(QMouseEvent * event) override;
    inline void mousePressEvent_protected(QMouseEvent * event) { QWidget::mousePressEvent(event); }
    void mousePressEvent(QMouseEvent * event) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * event) { QWidget::mouseReleaseEvent(event); }
    void mouseReleaseEvent(QMouseEvent * event) override;
    inline void moveEvent_protected(QMoveEvent * event) { QWidget::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return QWidget::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * event) { QWidget::paintEvent(event); }
    void paintEvent(QPaintEvent * event) override;
    inline int receivers_protected(const char * signal) const { return QWidget::receivers(signal); }
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return QWidget::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { QWidget::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    inline QObject * sender_protected() const { return QWidget::sender(); }
    inline int senderSignalIndex_protected() const { return QWidget::senderSignalIndex(); }
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return QWidget::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { QWidget::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { QWidget::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { QWidget::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void updateMicroFocus_protected() { QWidget::updateMicroFocus(); }
    inline void wheelEvent_protected(QWheelEvent * event) { QWidget::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~QWidgetWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[48];
};

#  endif // SBK_QWIDGETWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_LOCATIONBARWRAPPER_H

