#ifndef SBK_MAINAPPLICATIONWRAPPER_H
#define SBK_MAINAPPLICATIONWRAPPER_H

#include <mainapplication.h>


// Extra includes
#include <qobject.h>
#include <QList>
#include <browserwindow.h>
#include <qurl.h>
#include <qbytearray.h>
#include <history.h>
#include <bookmarks.h>
#include <autofill.h>
#include <cookiejar.h>
#include <pluginproxy.h>
#include <networkmanager.h>
#include <downloadmanager.h>
#include <searchenginesmanager.h>
#include <desktopnotificationsfactory.h>
#include <mainapplication.h>
#include <qwebenginedownloaditem.h>
#include <qcoreevent.h>
#include <qwidget.h>
#include <qobjectdefs.h>
namespace PySide { class DynamicQMetaObject; }

class MainApplicationWrapper : public MainApplication
{
public:
    inline void childEvent_protected(QChildEvent * event) { MainApplication::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { MainApplication::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { MainApplication::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { MainApplication::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline bool event_protected(QEvent * arg__1) { return MainApplication::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    const QMetaObject * metaObject() const override;
    bool notify(QObject * arg__1, QEvent * arg__2) override;
    inline void timerEvent_protected(QTimerEvent * event) { MainApplication::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~MainApplicationWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#  ifndef SBK_QTSINGLEAPPLICATIONWRAPPER_H
#  define SBK_QTSINGLEAPPLICATIONWRAPPER_H

// Inherited base class:
class QtSingleApplicationWrapper : public QtSingleApplication
{
public:
    inline void childEvent_protected(QChildEvent * event) { QtSingleApplication::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QtSingleApplication::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QtSingleApplication::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QtSingleApplication::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline bool event_protected(QEvent * arg__1) { return QtSingleApplication::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    const QMetaObject * metaObject() const override;
    bool notify(QObject * arg__1, QEvent * arg__2) override;
    inline void timerEvent_protected(QTimerEvent * event) { QtSingleApplication::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QtSingleApplicationWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#  endif // SBK_QTSINGLEAPPLICATIONWRAPPER_H

#  ifndef SBK_QAPPLICATIONWRAPPER_H
#  define SBK_QAPPLICATIONWRAPPER_H

// Inherited base class:
class QApplicationWrapper : public QApplication
{
public:
    QApplicationWrapper(int & argc, char ** argv, int arg__3 = ApplicationFlags);
    inline void childEvent_protected(QChildEvent * event) { QApplication::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QApplication::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QApplication::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QApplication::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline bool event_protected(QEvent * arg__1) { return QApplication::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    const QMetaObject * metaObject() const override;
    bool notify(QObject * arg__1, QEvent * arg__2) override;
    inline void timerEvent_protected(QTimerEvent * event) { QApplication::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QApplicationWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#  endif // SBK_QAPPLICATIONWRAPPER_H

#  ifndef SBK_QGUIAPPLICATIONWRAPPER_H
#  define SBK_QGUIAPPLICATIONWRAPPER_H

// Inherited base class:
class QGuiApplicationWrapper : public QGuiApplication
{
public:
    QGuiApplicationWrapper(int & argc, char ** argv, int arg__3 = ApplicationFlags);
    inline void childEvent_protected(QChildEvent * event) { QGuiApplication::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QGuiApplication::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QGuiApplication::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QGuiApplication::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline bool event_protected(QEvent * arg__1) { return QGuiApplication::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    const QMetaObject * metaObject() const override;
    bool notify(QObject * arg__1, QEvent * arg__2) override;
    inline void timerEvent_protected(QTimerEvent * event) { QGuiApplication::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QGuiApplicationWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#  endif // SBK_QGUIAPPLICATIONWRAPPER_H

#  ifndef SBK_QCOREAPPLICATIONWRAPPER_H
#  define SBK_QCOREAPPLICATIONWRAPPER_H

// Inherited base class:
class QCoreApplicationWrapper : public QCoreApplication
{
public:
    QCoreApplicationWrapper(int & argc, char ** argv, int arg__3 = ApplicationFlags);
    inline void childEvent_protected(QChildEvent * event) { QCoreApplication::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QCoreApplication::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QCoreApplication::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QCoreApplication::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline bool event_protected(QEvent * arg__1) { return QCoreApplication::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QCoreApplication::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    bool notify(QObject * arg__1, QEvent * arg__2) override;
    inline int receivers_protected(const char * signal) const { return QCoreApplication::receivers(signal); }
    inline QObject * sender_protected() const { return QCoreApplication::sender(); }
    inline int senderSignalIndex_protected() const { return QCoreApplication::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QCoreApplication::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QCoreApplicationWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9];
};

#  endif // SBK_QCOREAPPLICATIONWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_MAINAPPLICATIONWRAPPER_H

