#ifndef SBK_PASSWORDBACKENDWRAPPER_H
#define SBK_PASSWORDBACKENDWRAPPER_H

#include <passwordbackends/passwordbackend.h>


// Extra includes
#include <qurl.h>
#include <QVector>
#include <passwordmanager.h>
#include <qwidget.h>
class PasswordBackendWrapper : public PasswordBackend
{
public:
    PasswordBackendWrapper();
    void addEntry(const PasswordEntry & entry) override;
    QVector<PasswordEntry > getAllEntries() override;
    QVector<PasswordEntry > getEntries(const QUrl & url) override;
    QStringList getUsernames(const QUrl & url) override;
    bool hasSettings() const override;
    QString name() const override;
    void removeAll() override;
    void removeEntry(const PasswordEntry & entry) override;
    void setActive(bool active) override;
    void showSettings(QWidget * parent) override;
    bool updateEntry(const PasswordEntry & entry) override;
    void updateLastUsed(PasswordEntry & entry) override;
    ~PasswordBackendWrapper();
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[12];
};

#endif // SBK_PASSWORDBACKENDWRAPPER_H

