#ifndef SBK_PLUGINSWRAPPER_H
#define SBK_PLUGINSWRAPPER_H

#include <plugins.h>


// Extra includes
#include <qobject.h>
#include <QList>
#include <plugins.h>
#include <desktopfile.h>
#include <plugininterface.h>
#include <qcoreevent.h>
#include <qobjectdefs.h>
#include <qbytearray.h>
namespace PySide { class DynamicQMetaObject; }

class PluginsWrapper : public Plugins
{
public:
    PluginsWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { Plugins::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { Plugins::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { Plugins::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { Plugins::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return Plugins::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return Plugins::receivers(signal); }
    inline QObject * sender_protected() const { return Plugins::sender(); }
    inline int senderSignalIndex_protected() const { return Plugins::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { Plugins::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline QList<PluginInterface* > * protected_m_loadedPlugins_getter() { return  &this->Plugins::m_loadedPlugins; }
    inline void protected_m_loadedPlugins_setter(QList<PluginInterface* > value) { Plugins::m_loadedPlugins = value; }
    ~PluginsWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_PLUGINSWRAPPER_H

