

#ifndef SBK_PYFALKON_PYTHON_H
#define SBK_PYFALKON_PYTHON_H

#include <sbkpython.h>
#include <sbkconverter.h>
// Module Includes
#include <pyside2_qtwebenginecore_python.h>
#include <pyside2_qtcore_python.h>
#include <pyside2_qtnetwork_python.h>
#include <pyside2_qtwebenginewidgets_python.h>
#include <pyside2_qtgui_python.h>
#include <pyside2_qtwidgets_python.h>
#include <pyside2_qtwebchannel_python.h>
#include <pyside2_qtprintsupport_python.h>
#include <pyside2_qtsql_python.h>

// Bound library includes
#include <qtsingleapplication/qtsingleapplication.h>
#include <loadrequest.h>
#include <webview.h>
#include <clickablelabel.h>
#include <tabmodel.h>
#include <squeezelabelv1.h>
#include <autofill.h>
#include <bookmarkstools.h>
#include <historymodel.h>
#include <sqldatabase.h>
#include <navigationbar.h>
#include <webhittestresult.h>
#include <tabbedwebview.h>
#include <downloadmanager.h>
#include <wheelhelper.h>
#include <browserwindow.h>
#include <historyitem.h>
#include <toolbutton.h>
#include <desktopfile.h>
#include <cookiemanager.h>
#include <abstractbuttoninterface.h>
#include <qzcommon.h>
#include <datapaths.h>
#include <tabwidget.h>
#include <autosaver.h>
#include <pluginproxy.h>
#include <tabtreemodel.h>
#include <plugins.h>
#include <checkboxdialog.h>
#include <plugininterface.h>
#include <bookmarksmodel.h>
#include <tabstackedwidget.h>
#include <downloaditem.h>
#include <webinspector.h>
#include <combotabbar.h>
#include <squeezelabelv2.h>
#include <schemehandlers/extensionschemehandler.h>
#include <mainapplication.h>
#include <urlinterceptor.h>
#include <lineedit.h>
#include <cookiejar.h>
#include <desktopnotificationsfactory.h>
#include <networkmanager.h>
#include <history.h>
#include <locationbar.h>
#include <searchenginesdialog.h>
#include <delayedfilewatcher.h>
#include <qzsettings.h>
#include <javascript/externaljsobject.h>
#include <tabcontextmenu.h>
#include <webtab.h>
#include <bookmarkitem.h>
#include <webpage.h>
#include <bookmarks.h>
#include <tabbar.h>
#include <passwordmanager.h>
#include <sidebarinterface.h>
#include <statusbar.h>
#include <tabicon.h>
#include <qztools.h>
#include <sidebar.h>
#include <searchtoolbar.h>
#include <iconprovider.h>
#include <enhancedmenu.h>
#include <tabmrumodel.h>
#include <searchenginesmanager.h>
#include <passwordbackends/passwordbackend.h>
#include <settings.h>
// Conversion Includes - Primitive Types
#include <qabstractitemmodel.h>
#include <QString>
#include <QStringList>
#include <signalmanager.h>

// Conversion Includes - Container Types
#include <pysideqflags.h>
#include <QLinkedList>
#include <QList>
#include <QMap>
#include <QMultiMap>
#include <QPair>
#include <QQueue>
#include <QSet>
#include <QStack>
#include <QVector>

// Type indices
enum : int {
    SBK_ABSTRACTBUTTONINTERFACE_IDX                          = 0,
    SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX          = 1,
    SBK_ACTION_IDX                                           = 2,
    SBK_AUTOFILL_IDX                                         = 3,
    SBK_AUTOSAVER_IDX                                        = 4,
    SBK_BOOKMARKITEM_TYPE_IDX                                = 6,
    SBK_BOOKMARKITEM_IDX                                     = 5,
    SBK_BOOKMARKS_IDX                                        = 7,
    SBK_BOOKMARKSFOLDERSBUTTON_IDX                           = 8,
    SBK_BOOKMARKSFOLDERSMENU_IDX                             = 9,
    SBK_BOOKMARKSMODEL_ROLES_IDX                             = 11,
    SBK_BOOKMARKSMODEL_IDX                                   = 10,
    SBK_BOOKMARKSTOOLS_IDX                                   = 12,
    SBK_BROWSERWINDOW_IDX                                    = 13,
    SBK_CHECKBOXDIALOG_IDX                                   = 14,
    SBK_CLICKABLELABEL_IDX                                   = 15,
    SBK_COMBOTABBAR_SIZETYPE_IDX                             = 18,
    SBK_COMBOTABBAR_DROPINDICATORPOSITION_IDX                = 17,
    SBK_COMBOTABBAR_IDX                                      = 16,
    SBK_COOKIEJAR_IDX                                        = 19,
    SBK_COOKIEMANAGER_IDX                                    = 20,
    SBK_DATAPATHS_PATH_IDX                                   = 22,
    SBK_DATAPATHS_IDX                                        = 21,
    SBK_DELAYEDFILEWATCHER_IDX                               = 23,
    SBK_DESKTOPFILE_IDX                                      = 24,
    SBK_DESKTOPNOTIFICATIONSFACTORY_TYPE_IDX                 = 26,
    SBK_DESKTOPNOTIFICATIONSFACTORY_IDX                      = 25,
    SBK_DOWNLOADITEM_IDX                                     = 27,
    SBK_DOWNLOADMANAGER_DOWNLOADOPTION_IDX                   = 30,
    SBK_DOWNLOADMANAGER_IDX                                  = 28,
    SBK_DOWNLOADMANAGER_DOWNLOADINFO_IDX                     = 29,
    SBK_EXTENSIONSCHEMEHANDLER_IDX                           = 31,
    SBK_EXTERNALJSOBJECT_IDX                                 = 32,
    SBK_HISTORY_IDX                                          = 33,
    SBK_HISTORY_HISTORYENTRY_IDX                             = 34,
    SBK_HISTORYITEM_IDX                                      = 35,
    SBK_HISTORYMODEL_ROLES_IDX                               = 37,
    SBK_HISTORYMODEL_IDX                                     = 36,
    SBK_ICONPROVIDER_IDX                                     = 38,
    SBK_LINEEDIT_WIDGETPOSITION_IDX                          = 41,
    SBK_LINEEDIT_EDITACTION_IDX                              = 40,
    SBK_LINEEDIT_IDX                                         = 39,
    SBK_LOADREQUEST_OPERATION_IDX                            = 43,
    SBK_LOADREQUEST_IDX                                      = 42,
    SBK_LOCATIONBAR_IDX                                      = 44,
    SBK_LOCATIONBAR_LOADACTION_TYPE_IDX                      = 46,
    SBK_LOCATIONBAR_LOADACTION_IDX                           = 45,
    SBK_MAINAPPLICATION_AFTERLAUNCH_IDX                      = 48,
    SBK_MAINAPPLICATION_IDX                                  = 47,
    SBK_MENU_IDX                                             = 49,
    SBK_NAVIGATIONBAR_IDX                                    = 50,
    SBK_NETWORKMANAGER_IDX                                   = 51,
    SBK_PAGEFORMDATA_IDX                                     = 52,
    SBK_PASSWORDBACKEND_IDX                                  = 53,
    SBK_PASSWORDENTRY_IDX                                    = 54,
    SBK_PASSWORDMANAGER_IDX                                  = 55,
    SBK_PLUGININTERFACE_INITSTATE_IDX                        = 57,
    SBK_PLUGININTERFACE_IDX                                  = 56,
    SBK_PLUGINPROXY_EVENTHANDLERTYPE_IDX                     = 59,
    SBK_PLUGINPROXY_IDX                                      = 58,
    SBK_PLUGINSPEC_IDX                                       = 60,
    SBK_PLUGINS_IDX                                          = 61,
    SBK_PLUGINS_PLUGIN_TYPE_IDX                              = 63,
    SBK_PLUGINS_PLUGIN_IDX                                   = 62,
    SBK_QTSINGLEAPPLICATION_IDX                              = 66,
    SBK_QZ_BROWSERWINDOWTYPE_IDX                             = 68,
    SBK_QZ_COMMANDLINEACTION_IDX                             = 69,
    SBK_QZ_OBJECTNAME_IDX                                    = 71,
    SBK_QZ_NEWTABPOSITIONFLAG_IDX                            = 70,
    SBK_QFLAGS_QZ_NEWTABPOSITIONFLAG_IDX                     = 64,
    SBK_PyFalkonQZ_IDX                                       = 67,
    SBK_QZSETTINGS_IDX                                       = 72,
    SBK_QZTOOLS_IDX                                          = 73,
    SBK_SEARCHENGINESDIALOG_IDX                              = 74,
    SBK_SEARCHENGINESMANAGER_IDX                             = 75,
    SBK_SEARCHENGINESMANAGER_ENGINE_IDX                      = 76,
    SBK_SEARCHTOOLBAR_IDX                                    = 77,
    SBK_SETTINGS_IDX                                         = 78,
    SBK_SIDEBARINTERFACE_IDX                                 = 79,
    SBK_SIDEBARMANAGER_IDX                                   = 80,
    SBK_SIDEWIDGET_IDX                                       = 81,
    SBK_SQLDATABASE_IDX                                      = 82,
    SBK_SQLQUERYJOB_IDX                                      = 83,
    SBK_SQUEEZELABELV1_IDX                                   = 84,
    SBK_SQUEEZELABELV2_IDX                                   = 85,
    SBK_STATUSBAR_IDX                                        = 86,
    SBK_TABBAR_IDX                                           = 87,
    SBK_TABCONTEXTMENU_OPTION_IDX                            = 89,
    SBK_QFLAGS_TABCONTEXTMENU_OPTION_IDX                     = 65,
    SBK_TABCONTEXTMENU_IDX                                   = 88,
    SBK_TABICON_IDX                                          = 90,
    SBK_TABICON_DATA_IDX                                     = 91,
    SBK_TABMODEL_ROLES_IDX                                   = 93,
    SBK_TABMODEL_IDX                                         = 92,
    SBK_TABMRUMODEL_IDX                                      = 94,
    SBK_TABSTACKEDWIDGET_IDX                                 = 95,
    SBK_TABTREEMODEL_IDX                                     = 96,
    SBK_TABWIDGET_IDX                                        = 97,
    SBK_TABBEDWEBVIEW_IDX                                    = 98,
    SBK_TOOLBUTTON_IDX                                       = 99,
    SBK_URLINTERCEPTOR_IDX                                   = 100,
    SBK_WEBHITTESTRESULT_IDX                                 = 101,
    SBK_WEBINSPECTOR_IDX                                     = 102,
    SBK_WEBPAGE_JSWORLD_IDX                                  = 104,
    SBK_WEBPAGE_IDX                                          = 103,
    SBK_WEBTAB_ADDCHILDBEHAVIOR_IDX                          = 106,
    SBK_WEBTAB_IDX                                           = 105,
    SBK_WEBVIEW_IDX                                          = 107,
    SBK_WHEELHELPER_DIRECTION_IDX                            = 109,
    SBK_WHEELHELPER_IDX                                      = 108,
    SBK_PyFalkon_IDX_COUNT                                   = 110
};
// This variable stores all Python types exported by this module.
extern PyTypeObject **SbkPyFalkonTypes;

// This variable stores the Python module object exported by this module.
extern PyObject *SbkPyFalkonModuleObject;

// This variable stores all type converters exported by this module.
extern SbkConverter **SbkPyFalkonTypeConverters;

// Converter indices
enum : int {
    SBK_PYFALKON_QLIST_QOBJECTPTR_IDX                        = 0, // const QList<QObject* > &
    SBK_PYFALKON_QLIST_QBYTEARRAY_IDX                        = 1, // QList<QByteArray >
    SBK_PYFALKON_QLIST_QGRAPHICSWIDGETPTR_IDX                = 2, // QList<QGraphicsWidget* >
    SBK_PYFALKON_QLIST_QWIDGETPTR_IDX                        = 3, // QList<QWidget* >
    SBK_PYFALKON_QLIST_QKEYSEQUENCE_IDX                      = 4, // const QList<QKeySequence > &
    SBK_PYFALKON_QVECTOR_PASSWORDENTRY_IDX                   = 5, // QVector<PasswordEntry >
    SBK_PYFALKON_QLIST_BOOKMARKITEMPTR_IDX                   = 6, // QList<BookmarkItem* >
    SBK_PYFALKON_QMAP_QSTRING_QVARIANT_IDX                   = 7, // const QMap<QString,QVariant > &
    SBK_PYFALKON_QLIST_QVARIANT_IDX                          = 8, // const QList<QVariant > &
    SBK_PYFALKON_QLIST_QACTIONPTR_IDX                        = 9, // QList<QAction* >
    SBK_PYFALKON_QVECTOR_INT_IDX                             = 10, // const QVector<int > &
    SBK_PYFALKON_QHASH_INT_QBYTEARRAY_IDX                    = 11, // const QHash<int,QByteArray > &
    SBK_PYFALKON_QMAP_INT_QVARIANT_IDX                       = 12, // QMap<int,QVariant >
    SBK_PYFALKON_QLIST_QPERSISTENTMODELINDEX_IDX             = 13, // const QList<QPersistentModelIndex > &
    SBK_PYFALKON_QLIST_QDOCKWIDGETPTR_IDX                    = 14, // const QList<QDockWidget* > &
    SBK_PYFALKON_QLIST_INT_IDX                               = 15, // const QList<int > &
    SBK_PYFALKON_QHASH_QSTRING_QVARIANT_IDX                  = 16, // const QHash<QString,QVariant > &
    SBK_PYFALKON_QLIST_QABSTRACTBUTTONPTR_IDX                = 17, // QList<QAbstractButton* >
    SBK_PYFALKON_QVECTOR_QNETWORKCOOKIE_IDX                  = 18, // QVector<QNetworkCookie >
    SBK_PYFALKON_QVECTOR_HISTORY_HISTORYENTRY_IDX            = 19, // QVector<History::HistoryEntry >
    SBK_PYFALKON_QLIST_HISTORY_HISTORYENTRY_IDX              = 20, // QList<History::HistoryEntry >
    SBK_PYFALKON_QLIST_QTEXTLAYOUT_FORMATRANGE_IDX           = 21, // const QList<QTextLayout::FormatRange > &
    SBK_PYFALKON_QLIST_BROWSERWINDOWPTR_IDX                  = 22, // QList<BrowserWindow* >
    SBK_PYFALKON_QVECTOR_QHSTSPOLICY_IDX                     = 23, // const QVector<QHstsPolicy > &
    SBK_PYFALKON_QLIST_QSSLERROR_IDX                         = 24, // const QList<QSslError > &
    SBK_PYFALKON_QHASH_QSTRING_PASSWORDBACKENDPTR_IDX        = 25, // QHash<QString,PasswordBackend* >
    SBK_PYFALKON_QLIST_PLUGINS_PLUGIN_IDX                    = 26, // QList<Plugins::Plugin >
    SBK_PYFALKON_QLIST_PLUGININTERFACEPTR_IDX                = 27, // QList<PluginInterface* >
    SBK_PYFALKON_QVECTOR_SEARCHENGINESMANAGER_ENGINE_IDX     = 28, // QVector<SearchEnginesManager::Engine >
    SBK_PYFALKON_QVECTOR_QSQLRECORD_IDX                      = 29, // QVector<QSqlRecord >
    SBK_PYFALKON_QLIST_WEBTABPTR_IDX                         = 30, // QList<WebTab* >
    SBK_PYFALKON_QVECTOR_WEBTABPTR_IDX                       = 31, // QVector<WebTab* >
    SBK_PYFALKON_QLIST_QSTRING_IDX                           = 32, // QList<QString >
    SBK_PyFalkon_CONVERTERS_IDX_COUNT                        = 33
};
// Macros for type check

namespace Shiboken
{

// PyType functions, to get the PyObjectType for a type T
QT_WARNING_PUSH
QT_WARNING_DISABLE_DEPRECATED
template<> inline PyTypeObject *SbkType< ::AbstractButtonInterface >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_IDX]); }
template<> inline PyTypeObject *SbkType< ::AbstractButtonInterface::ClickController >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_ABSTRACTBUTTONINTERFACE_CLICKCONTROLLER_IDX]); }
template<> inline PyTypeObject *SbkType< ::Action >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_ACTION_IDX]); }
template<> inline PyTypeObject *SbkType< ::AutoFill >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_AUTOFILL_IDX]); }
template<> inline PyTypeObject *SbkType< ::AutoSaver >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_AUTOSAVER_IDX]); }
template<> inline PyTypeObject *SbkType< ::BookmarkItem::Type >() { return SbkPyFalkonTypes[SBK_BOOKMARKITEM_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::BookmarkItem >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_BOOKMARKITEM_IDX]); }
template<> inline PyTypeObject *SbkType< ::Bookmarks >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_BOOKMARKS_IDX]); }
template<> inline PyTypeObject *SbkType< ::BookmarksFoldersButton >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_BOOKMARKSFOLDERSBUTTON_IDX]); }
template<> inline PyTypeObject *SbkType< ::BookmarksFoldersMenu >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_BOOKMARKSFOLDERSMENU_IDX]); }
template<> inline PyTypeObject *SbkType< ::BookmarksModel::Roles >() { return SbkPyFalkonTypes[SBK_BOOKMARKSMODEL_ROLES_IDX]; }
template<> inline PyTypeObject *SbkType< ::BookmarksModel >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_BOOKMARKSMODEL_IDX]); }
template<> inline PyTypeObject *SbkType< ::BookmarksTools >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_BOOKMARKSTOOLS_IDX]); }
template<> inline PyTypeObject *SbkType< ::BrowserWindow >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_BROWSERWINDOW_IDX]); }
template<> inline PyTypeObject *SbkType< ::CheckBoxDialog >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_CHECKBOXDIALOG_IDX]); }
template<> inline PyTypeObject *SbkType< ::ClickableLabel >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_CLICKABLELABEL_IDX]); }
template<> inline PyTypeObject *SbkType< ::ComboTabBar::SizeType >() { return SbkPyFalkonTypes[SBK_COMBOTABBAR_SIZETYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::ComboTabBar::DropIndicatorPosition >() { return SbkPyFalkonTypes[SBK_COMBOTABBAR_DROPINDICATORPOSITION_IDX]; }
template<> inline PyTypeObject *SbkType< ::ComboTabBar >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_COMBOTABBAR_IDX]); }
template<> inline PyTypeObject *SbkType< ::CookieJar >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_COOKIEJAR_IDX]); }
template<> inline PyTypeObject *SbkType< ::CookieManager >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_COOKIEMANAGER_IDX]); }
template<> inline PyTypeObject *SbkType< ::DataPaths::Path >() { return SbkPyFalkonTypes[SBK_DATAPATHS_PATH_IDX]; }
template<> inline PyTypeObject *SbkType< ::DataPaths >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_DATAPATHS_IDX]); }
template<> inline PyTypeObject *SbkType< ::DelayedFileWatcher >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_DELAYEDFILEWATCHER_IDX]); }
template<> inline PyTypeObject *SbkType< ::DesktopFile >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_DESKTOPFILE_IDX]); }
template<> inline PyTypeObject *SbkType< ::DesktopNotificationsFactory::Type >() { return SbkPyFalkonTypes[SBK_DESKTOPNOTIFICATIONSFACTORY_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::DesktopNotificationsFactory >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_DESKTOPNOTIFICATIONSFACTORY_IDX]); }
template<> inline PyTypeObject *SbkType< ::DownloadItem >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_DOWNLOADITEM_IDX]); }
template<> inline PyTypeObject *SbkType< ::DownloadManager::DownloadOption >() { return SbkPyFalkonTypes[SBK_DOWNLOADMANAGER_DOWNLOADOPTION_IDX]; }
template<> inline PyTypeObject *SbkType< ::DownloadManager >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_DOWNLOADMANAGER_IDX]); }
template<> inline PyTypeObject *SbkType< ::DownloadManager::DownloadInfo >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_DOWNLOADMANAGER_DOWNLOADINFO_IDX]); }
template<> inline PyTypeObject *SbkType< ::ExtensionSchemeHandler >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_EXTENSIONSCHEMEHANDLER_IDX]); }
template<> inline PyTypeObject *SbkType< ::ExternalJsObject >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_EXTERNALJSOBJECT_IDX]); }
template<> inline PyTypeObject *SbkType< ::History >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_HISTORY_IDX]); }
template<> inline PyTypeObject *SbkType< ::History::HistoryEntry >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_HISTORY_HISTORYENTRY_IDX]); }
template<> inline PyTypeObject *SbkType< ::HistoryItem >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_HISTORYITEM_IDX]); }
template<> inline PyTypeObject *SbkType< ::HistoryModel::Roles >() { return SbkPyFalkonTypes[SBK_HISTORYMODEL_ROLES_IDX]; }
template<> inline PyTypeObject *SbkType< ::HistoryModel >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_HISTORYMODEL_IDX]); }
template<> inline PyTypeObject *SbkType< ::IconProvider >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_ICONPROVIDER_IDX]); }
template<> inline PyTypeObject *SbkType< ::LineEdit::WidgetPosition >() { return SbkPyFalkonTypes[SBK_LINEEDIT_WIDGETPOSITION_IDX]; }
template<> inline PyTypeObject *SbkType< ::LineEdit::EditAction >() { return SbkPyFalkonTypes[SBK_LINEEDIT_EDITACTION_IDX]; }
template<> inline PyTypeObject *SbkType< ::LineEdit >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_LINEEDIT_IDX]); }
template<> inline PyTypeObject *SbkType< ::LoadRequest::Operation >() { return SbkPyFalkonTypes[SBK_LOADREQUEST_OPERATION_IDX]; }
template<> inline PyTypeObject *SbkType< ::LoadRequest >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_LOADREQUEST_IDX]); }
template<> inline PyTypeObject *SbkType< ::LocationBar >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_LOCATIONBAR_IDX]); }
template<> inline PyTypeObject *SbkType< ::LocationBar::LoadAction::Type >() { return SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::LocationBar::LoadAction >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_LOCATIONBAR_LOADACTION_IDX]); }
template<> inline PyTypeObject *SbkType< ::MainApplication::AfterLaunch >() { return SbkPyFalkonTypes[SBK_MAINAPPLICATION_AFTERLAUNCH_IDX]; }
template<> inline PyTypeObject *SbkType< ::MainApplication >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_MAINAPPLICATION_IDX]); }
template<> inline PyTypeObject *SbkType< ::Menu >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_MENU_IDX]); }
template<> inline PyTypeObject *SbkType< ::NavigationBar >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_NAVIGATIONBAR_IDX]); }
template<> inline PyTypeObject *SbkType< ::NetworkManager >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_NETWORKMANAGER_IDX]); }
template<> inline PyTypeObject *SbkType< ::PageFormData >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PAGEFORMDATA_IDX]); }
template<> inline PyTypeObject *SbkType< ::PasswordBackend >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PASSWORDBACKEND_IDX]); }
template<> inline PyTypeObject *SbkType< ::PasswordEntry >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PASSWORDENTRY_IDX]); }
template<> inline PyTypeObject *SbkType< ::PasswordManager >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PASSWORDMANAGER_IDX]); }
template<> inline PyTypeObject *SbkType< ::PluginInterface::InitState >() { return SbkPyFalkonTypes[SBK_PLUGININTERFACE_INITSTATE_IDX]; }
template<> inline PyTypeObject *SbkType< ::PluginInterface >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PLUGININTERFACE_IDX]); }
template<> inline PyTypeObject *SbkType< ::PluginProxy::EventHandlerType >() { return SbkPyFalkonTypes[SBK_PLUGINPROXY_EVENTHANDLERTYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::PluginProxy >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PLUGINPROXY_IDX]); }
template<> inline PyTypeObject *SbkType< ::PluginSpec >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PLUGINSPEC_IDX]); }
template<> inline PyTypeObject *SbkType< ::Plugins >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PLUGINS_IDX]); }
template<> inline PyTypeObject *SbkType< ::Plugins::Plugin::Type >() { return SbkPyFalkonTypes[SBK_PLUGINS_PLUGIN_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::Plugins::Plugin >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_PLUGINS_PLUGIN_IDX]); }
template<> inline PyTypeObject *SbkType< ::QtSingleApplication >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_QTSINGLEAPPLICATION_IDX]); }
template<> inline PyTypeObject *SbkType< ::Qz::BrowserWindowType >() { return SbkPyFalkonTypes[SBK_QZ_BROWSERWINDOWTYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::Qz::CommandLineAction >() { return SbkPyFalkonTypes[SBK_QZ_COMMANDLINEACTION_IDX]; }
template<> inline PyTypeObject *SbkType< ::Qz::ObjectName >() { return SbkPyFalkonTypes[SBK_QZ_OBJECTNAME_IDX]; }
template<> inline PyTypeObject *SbkType< ::Qz::NewTabPositionFlag >() { return SbkPyFalkonTypes[SBK_QZ_NEWTABPOSITIONFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<Qz::NewTabPositionFlag> >() { return SbkPyFalkonTypes[SBK_QFLAGS_QZ_NEWTABPOSITIONFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QzSettings >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_QZSETTINGS_IDX]); }
template<> inline PyTypeObject *SbkType< ::QzTools >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_QZTOOLS_IDX]); }
template<> inline PyTypeObject *SbkType< ::SearchEnginesDialog >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SEARCHENGINESDIALOG_IDX]); }
template<> inline PyTypeObject *SbkType< ::SearchEnginesManager >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SEARCHENGINESMANAGER_IDX]); }
template<> inline PyTypeObject *SbkType< ::SearchEnginesManager::Engine >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SEARCHENGINESMANAGER_ENGINE_IDX]); }
template<> inline PyTypeObject *SbkType< ::SearchToolBar >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SEARCHTOOLBAR_IDX]); }
template<> inline PyTypeObject *SbkType< ::Settings >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SETTINGS_IDX]); }
template<> inline PyTypeObject *SbkType< ::SideBarInterface >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SIDEBARINTERFACE_IDX]); }
template<> inline PyTypeObject *SbkType< ::SideBarManager >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SIDEBARMANAGER_IDX]); }
template<> inline PyTypeObject *SbkType< ::SideWidget >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SIDEWIDGET_IDX]); }
template<> inline PyTypeObject *SbkType< ::SqlDatabase >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SQLDATABASE_IDX]); }
template<> inline PyTypeObject *SbkType< ::SqlQueryJob >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SQLQUERYJOB_IDX]); }
template<> inline PyTypeObject *SbkType< ::SqueezeLabelV1 >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SQUEEZELABELV1_IDX]); }
template<> inline PyTypeObject *SbkType< ::SqueezeLabelV2 >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_SQUEEZELABELV2_IDX]); }
template<> inline PyTypeObject *SbkType< ::StatusBar >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_STATUSBAR_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabBar >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABBAR_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabContextMenu::Option >() { return SbkPyFalkonTypes[SBK_TABCONTEXTMENU_OPTION_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<TabContextMenu::Option> >() { return SbkPyFalkonTypes[SBK_QFLAGS_TABCONTEXTMENU_OPTION_IDX]; }
template<> inline PyTypeObject *SbkType< ::TabContextMenu >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABCONTEXTMENU_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabIcon >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABICON_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabIcon::Data >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABICON_DATA_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabModel::Roles >() { return SbkPyFalkonTypes[SBK_TABMODEL_ROLES_IDX]; }
template<> inline PyTypeObject *SbkType< ::TabModel >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABMODEL_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabMruModel >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABMRUMODEL_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabStackedWidget >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABSTACKEDWIDGET_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabTreeModel >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABTREEMODEL_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabWidget >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABWIDGET_IDX]); }
template<> inline PyTypeObject *SbkType< ::TabbedWebView >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TABBEDWEBVIEW_IDX]); }
template<> inline PyTypeObject *SbkType< ::ToolButton >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_TOOLBUTTON_IDX]); }
template<> inline PyTypeObject *SbkType< ::UrlInterceptor >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_URLINTERCEPTOR_IDX]); }
template<> inline PyTypeObject *SbkType< ::WebHitTestResult >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_WEBHITTESTRESULT_IDX]); }
template<> inline PyTypeObject *SbkType< ::WebInspector >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_WEBINSPECTOR_IDX]); }
template<> inline PyTypeObject *SbkType< ::WebPage::JsWorld >() { return SbkPyFalkonTypes[SBK_WEBPAGE_JSWORLD_IDX]; }
template<> inline PyTypeObject *SbkType< ::WebPage >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_WEBPAGE_IDX]); }
template<> inline PyTypeObject *SbkType< ::WebTab::AddChildBehavior >() { return SbkPyFalkonTypes[SBK_WEBTAB_ADDCHILDBEHAVIOR_IDX]; }
template<> inline PyTypeObject *SbkType< ::WebTab >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_WEBTAB_IDX]); }
template<> inline PyTypeObject *SbkType< ::WebView >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_WEBVIEW_IDX]); }
template<> inline PyTypeObject *SbkType< ::WheelHelper::Direction >() { return SbkPyFalkonTypes[SBK_WHEELHELPER_DIRECTION_IDX]; }
template<> inline PyTypeObject *SbkType< ::WheelHelper >() { return reinterpret_cast<PyTypeObject *>(SbkPyFalkonTypes[SBK_WHEELHELPER_IDX]); }
QT_WARNING_POP

} // namespace Shiboken

#endif // SBK_PYFALKON_PYTHON_H

