#ifndef SBK_SIDEBARINTERFACEWRAPPER_H
#define SBK_SIDEBARINTERFACEWRAPPER_H

#include <sidebarinterface.h>


// Extra includes
#include <qobject.h>
#include <qaction.h>
#include <qwidget.h>
#include <browserwindow.h>
#include <qcoreevent.h>
#include <qobjectdefs.h>
#include <QList>
#include <qbytearray.h>
namespace PySide { class DynamicQMetaObject; }

class SideBarInterfaceWrapper : public SideBarInterface
{
public:
    SideBarInterfaceWrapper(QObject * parent = 0);
    inline void childEvent_protected(QChildEvent * event) { SideBarInterface::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { SideBarInterface::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    QAction * createMenuAction() override;
    QWidget * createSideBarWidget(BrowserWindow * mainWindow) override;
    inline void customEvent_protected(QEvent * event) { SideBarInterface::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { SideBarInterface::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return SideBarInterface::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return SideBarInterface::receivers(signal); }
    inline QObject * sender_protected() const { return SideBarInterface::sender(); }
    inline int senderSignalIndex_protected() const { return SideBarInterface::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { SideBarInterface::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    QString title() const override;
    ~SideBarInterfaceWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[11];
};

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_SIDEBARINTERFACEWRAPPER_H

