#ifndef SBK_TABBEDWEBVIEWWRAPPER_H
#define SBK_TABBEDWEBVIEWWRAPPER_H

#include <tabbedwebview.h>


// Extra includes
#include <qobject.h>
#include <webtab.h>
#include <webpage.h>
#include <browserwindow.h>
#include <qwidget.h>
#include <loadrequest.h>
#include <qevent.h>
#include <qmenu.h>
#include <qcoreevent.h>
#include <qsize.h>
#include <qbytearray.h>
#include <qicon.h>
#include <qurl.h>
#include <webhittestresult.h>
#include <qobjectdefs.h>
#include <qrect.h>
#include <qpoint.h>
#include <qpainter.h>
#include <qwebengineview.h>
#include <qaction.h>
#include <QList>
#include <qpaintdevice.h>
namespace PySide { class DynamicQMetaObject; }

class TabbedWebViewWrapper : public TabbedWebView
{
public:
    TabbedWebViewWrapper(WebTab * webTab);
    inline void _keyPressEvent_protected(QKeyEvent * event) { TabbedWebView::_keyPressEvent(event); }
    void _keyPressEvent(QKeyEvent * event) override;
    inline void _keyReleaseEvent_protected(QKeyEvent * event) { TabbedWebView::_keyReleaseEvent(event); }
    void _keyReleaseEvent(QKeyEvent * event) override;
    inline void _mousePressEvent_protected(QMouseEvent * event) { TabbedWebView::_mousePressEvent(event); }
    void _mousePressEvent(QMouseEvent * event) override;
    inline void _mouseReleaseEvent_protected(QMouseEvent * event) { TabbedWebView::_mouseReleaseEvent(event); }
    void _mouseReleaseEvent(QMouseEvent * event) override;
    inline void _wheelEvent_protected(QWheelEvent * event) { TabbedWebView::_wheelEvent(event); }
    void _wheelEvent(QWheelEvent * event) override;
    inline void actionEvent_protected(QActionEvent * event) { TabbedWebView::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void applyZoom_protected() { TabbedWebView::applyZoom(); }
    inline void bookmarkLink_protected() { TabbedWebView::bookmarkLink(); }
    inline void changeEvent_protected(QEvent * event) { TabbedWebView::changeEvent(event); }
    void changeEvent(QEvent * event) override;
    inline void checkForForm_protected(QAction * action, const QPoint & pos) { TabbedWebView::checkForForm(action, pos); }
    inline void childEvent_protected(QChildEvent * event) { TabbedWebView::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * arg__1) { TabbedWebView::closeEvent(arg__1); }
    void closeEvent(QCloseEvent * arg__1) override;
    void closeView() override;
    inline void connectNotify_protected(const QMetaMethod & signal) { TabbedWebView::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * event) { TabbedWebView::contextMenuEvent(event); }
    void contextMenuEvent(QContextMenuEvent * event) override;
    inline void copyImageToClipboard_protected() { TabbedWebView::copyImageToClipboard(); }
    inline void copyLinkToClipboard_protected() { TabbedWebView::copyLinkToClipboard(); }
    inline void createContextMenu_protected(QMenu * menu, WebHitTestResult & hitTest) { TabbedWebView::createContextMenu(menu, hitTest); }
    inline void createImageContextMenu_protected(QMenu * menu, const WebHitTestResult & hitTest) { TabbedWebView::createImageContextMenu(menu, hitTest); }
    inline void createLinkContextMenu_protected(QMenu * menu, const WebHitTestResult & hitTest) { TabbedWebView::createLinkContextMenu(menu, hitTest); }
    inline void createMediaContextMenu_protected(QMenu * menu, const WebHitTestResult & hitTest) { TabbedWebView::createMediaContextMenu(menu, hitTest); }
    inline void createPageContextMenu_protected(QMenu * menu) { TabbedWebView::createPageContextMenu(menu); }
    inline void createSearchEngine_protected() { TabbedWebView::createSearchEngine(); }
    inline void createSelectedTextContextMenu_protected(QMenu * menu, const WebHitTestResult & hitTest) { TabbedWebView::createSelectedTextContextMenu(menu, hitTest); }
    inline QWebEngineView * createWindow_protected(QWebEnginePage::WebWindowType type) { return TabbedWebView::createWindow(QWebEnginePage::WebWindowType(type)); }
    QWebEngineView * createWindow(QWebEnginePage::WebWindowType type) override;
    inline void customEvent_protected(QEvent * event) { TabbedWebView::customEvent(event); }
    void customEvent(QEvent * event) override;
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { TabbedWebView::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void downloadImageToDisk_protected() { TabbedWebView::downloadImageToDisk(); }
    inline void downloadLinkToDisk_protected() { TabbedWebView::downloadLinkToDisk(); }
    inline void downloadMediaToDisk_protected() { TabbedWebView::downloadMediaToDisk(); }
    inline void dragEnterEvent_protected(QDragEnterEvent * e) { TabbedWebView::dragEnterEvent(e); }
    void dragEnterEvent(QDragEnterEvent * e) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * e) { TabbedWebView::dragLeaveEvent(e); }
    void dragLeaveEvent(QDragLeaveEvent * e) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * e) { TabbedWebView::dragMoveEvent(e); }
    void dragMoveEvent(QDragMoveEvent * e) override;
    inline void dropEvent_protected(QDropEvent * e) { TabbedWebView::dropEvent(e); }
    void dropEvent(QDropEvent * e) override;
    inline void enterEvent_protected(QEvent * event) { TabbedWebView::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * arg__1) { return TabbedWebView::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * obj, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * event) { TabbedWebView::focusInEvent(event); }
    void focusInEvent(QFocusEvent * event) override;
    inline bool focusNextPrevChild_protected(bool next) { return TabbedWebView::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * event) { TabbedWebView::focusOutEvent(event); }
    void focusOutEvent(QFocusEvent * event) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * arg__1) { TabbedWebView::hideEvent(arg__1); }
    void hideEvent(QHideEvent * arg__1) override;
    inline void initPainter_protected(QPainter * painter) const { TabbedWebView::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { TabbedWebView::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    bool isFullScreen() override;
    inline void keyPressEvent_protected(QKeyEvent * event) { TabbedWebView::keyPressEvent(event); }
    void keyPressEvent(QKeyEvent * event) override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { TabbedWebView::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { TabbedWebView::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    void loadInNewTab(const LoadRequest & req, QFlags<Qz::NewTabPositionFlag> position) override;
    inline void loadRequest_protected(const LoadRequest & req) { TabbedWebView::loadRequest(req); }
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return TabbedWebView::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { TabbedWebView::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * event) { TabbedWebView::mouseMoveEvent(event); }
    void mouseMoveEvent(QMouseEvent * event) override;
    inline void mousePressEvent_protected(QMouseEvent * event) { TabbedWebView::mousePressEvent(event); }
    void mousePressEvent(QMouseEvent * event) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * event) { TabbedWebView::mouseReleaseEvent(event); }
    void mouseReleaseEvent(QMouseEvent * event) override;
    inline void moveEvent_protected(QMoveEvent * event) { TabbedWebView::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return TabbedWebView::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    inline void openActionUrl_protected() { TabbedWebView::openActionUrl(); }
    inline void openUrlInBackgroundTab_protected() { TabbedWebView::openUrlInBackgroundTab(); }
    inline void openUrlInNewWindow_protected() { TabbedWebView::openUrlInNewWindow(); }
    inline void openUrlInSelectedTab_protected() { TabbedWebView::openUrlInSelectedTab(); }
    QWidget * overlayWidget() override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * event) { TabbedWebView::paintEvent(event); }
    void paintEvent(QPaintEvent * event) override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return TabbedWebView::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    void requestFullScreen(bool enable) override;
    inline void resizeEvent_protected(QResizeEvent * event) { TabbedWebView::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    inline void savePageAs_protected() { TabbedWebView::savePageAs(); }
    inline void searchSelectedText_protected() { TabbedWebView::searchSelectedText(); }
    inline void searchSelectedTextInBackgroundTab_protected() { TabbedWebView::searchSelectedTextInBackgroundTab(); }
    inline void sendTextByMail_protected() { TabbedWebView::sendTextByMail(); }
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return TabbedWebView::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { TabbedWebView::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    inline void showSiteInfo_protected() { TabbedWebView::showSiteInfo(); }
    QSize sizeHint() const override;
    inline void slotIconChanged_protected() { TabbedWebView::slotIconChanged(); }
    inline void slotTitleChanged_protected(const QString & title) { TabbedWebView::slotTitleChanged(title); }
    inline void slotUrlChanged_protected(const QUrl & url) { TabbedWebView::slotUrlChanged(url); }
    inline void tabletEvent_protected(QTabletEvent * event) { TabbedWebView::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { TabbedWebView::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void userDefinedOpenUrlInBgTab_protected(const QUrl & url = QUrl()) { TabbedWebView::userDefinedOpenUrlInBgTab(url); }
    inline void userDefinedOpenUrlInNewTab_protected(const QUrl & url = QUrl(), bool invert = false) { TabbedWebView::userDefinedOpenUrlInNewTab(url, invert); }
    inline void wheelEvent_protected(QWheelEvent * event) { TabbedWebView::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~TabbedWebViewWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[61];
};

#  ifndef SBK_WEBVIEWWRAPPER_H
#  define SBK_WEBVIEWWRAPPER_H

// Inherited base class:
class WebViewWrapper : public WebView
{
public:
    WebViewWrapper(QWidget * parent = nullptr);
    inline void _contextMenuEvent_protected(QContextMenuEvent * event) { WebView::_contextMenuEvent(event); }
    void _contextMenuEvent(QContextMenuEvent * event) override;
    inline void _keyPressEvent_protected(QKeyEvent * event) { WebView::_keyPressEvent(event); }
    void _keyPressEvent(QKeyEvent * event) override;
    inline void _keyReleaseEvent_protected(QKeyEvent * event) { WebView::_keyReleaseEvent(event); }
    void _keyReleaseEvent(QKeyEvent * event) override;
    inline void _mouseMoveEvent_protected(QMouseEvent * event) { WebView::_mouseMoveEvent(event); }
    void _mouseMoveEvent(QMouseEvent * event) override;
    inline void _mousePressEvent_protected(QMouseEvent * event) { WebView::_mousePressEvent(event); }
    void _mousePressEvent(QMouseEvent * event) override;
    inline void _mouseReleaseEvent_protected(QMouseEvent * event) { WebView::_mouseReleaseEvent(event); }
    void _mouseReleaseEvent(QMouseEvent * event) override;
    inline void _wheelEvent_protected(QWheelEvent * event) { WebView::_wheelEvent(event); }
    void _wheelEvent(QWheelEvent * event) override;
    inline void actionEvent_protected(QActionEvent * event) { WebView::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void applyZoom_protected() { WebView::applyZoom(); }
    inline void bookmarkLink_protected() { WebView::bookmarkLink(); }
    inline void changeEvent_protected(QEvent * event) { WebView::changeEvent(event); }
    void changeEvent(QEvent * event) override;
    inline void checkForForm_protected(QAction * action, const QPoint & pos) { WebView::checkForForm(action, pos); }
    inline void childEvent_protected(QChildEvent * event) { WebView::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * arg__1) { WebView::closeEvent(arg__1); }
    void closeEvent(QCloseEvent * arg__1) override;
    void closeView() override;
    inline void connectNotify_protected(const QMetaMethod & signal) { WebView::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * event) { WebView::contextMenuEvent(event); }
    void contextMenuEvent(QContextMenuEvent * event) override;
    inline void copyImageToClipboard_protected() { WebView::copyImageToClipboard(); }
    inline void copyLinkToClipboard_protected() { WebView::copyLinkToClipboard(); }
    inline void createContextMenu_protected(QMenu * menu, WebHitTestResult & hitTest) { WebView::createContextMenu(menu, hitTest); }
    inline void createImageContextMenu_protected(QMenu * menu, const WebHitTestResult & hitTest) { WebView::createImageContextMenu(menu, hitTest); }
    inline void createLinkContextMenu_protected(QMenu * menu, const WebHitTestResult & hitTest) { WebView::createLinkContextMenu(menu, hitTest); }
    inline void createMediaContextMenu_protected(QMenu * menu, const WebHitTestResult & hitTest) { WebView::createMediaContextMenu(menu, hitTest); }
    inline void createPageContextMenu_protected(QMenu * menu) { WebView::createPageContextMenu(menu); }
    inline void createSearchEngine_protected() { WebView::createSearchEngine(); }
    inline void createSelectedTextContextMenu_protected(QMenu * menu, const WebHitTestResult & hitTest) { WebView::createSelectedTextContextMenu(menu, hitTest); }
    inline QWebEngineView * createWindow_protected(QWebEnginePage::WebWindowType type) { return WebView::createWindow(QWebEnginePage::WebWindowType(type)); }
    QWebEngineView * createWindow(QWebEnginePage::WebWindowType type) override;
    inline void customEvent_protected(QEvent * event) { WebView::customEvent(event); }
    void customEvent(QEvent * event) override;
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { WebView::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void downloadImageToDisk_protected() { WebView::downloadImageToDisk(); }
    inline void downloadLinkToDisk_protected() { WebView::downloadLinkToDisk(); }
    inline void downloadMediaToDisk_protected() { WebView::downloadMediaToDisk(); }
    inline void dragEnterEvent_protected(QDragEnterEvent * e) { WebView::dragEnterEvent(e); }
    void dragEnterEvent(QDragEnterEvent * e) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * e) { WebView::dragLeaveEvent(e); }
    void dragLeaveEvent(QDragLeaveEvent * e) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * e) { WebView::dragMoveEvent(e); }
    void dragMoveEvent(QDragMoveEvent * e) override;
    inline void dropEvent_protected(QDropEvent * e) { WebView::dropEvent(e); }
    void dropEvent(QDropEvent * e) override;
    inline void enterEvent_protected(QEvent * event) { WebView::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * arg__1) { return WebView::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * obj, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * event) { WebView::focusInEvent(event); }
    void focusInEvent(QFocusEvent * event) override;
    inline bool focusNextPrevChild_protected(bool next) { return WebView::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * event) { WebView::focusOutEvent(event); }
    void focusOutEvent(QFocusEvent * event) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * arg__1) { WebView::hideEvent(arg__1); }
    void hideEvent(QHideEvent * arg__1) override;
    inline void initPainter_protected(QPainter * painter) const { WebView::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { WebView::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    bool isFullScreen() override;
    inline void keyPressEvent_protected(QKeyEvent * event) { WebView::keyPressEvent(event); }
    void keyPressEvent(QKeyEvent * event) override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { WebView::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { WebView::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    void loadInNewTab(const LoadRequest & req, QFlags<Qz::NewTabPositionFlag> position) override;
    inline void loadRequest_protected(const LoadRequest & req) { WebView::loadRequest(req); }
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return WebView::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { WebView::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * event) { WebView::mouseMoveEvent(event); }
    void mouseMoveEvent(QMouseEvent * event) override;
    inline void mousePressEvent_protected(QMouseEvent * event) { WebView::mousePressEvent(event); }
    void mousePressEvent(QMouseEvent * event) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * event) { WebView::mouseReleaseEvent(event); }
    void mouseReleaseEvent(QMouseEvent * event) override;
    inline void moveEvent_protected(QMoveEvent * event) { WebView::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return WebView::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    inline void openActionUrl_protected() { WebView::openActionUrl(); }
    inline void openUrlInBackgroundTab_protected() { WebView::openUrlInBackgroundTab(); }
    inline void openUrlInNewWindow_protected() { WebView::openUrlInNewWindow(); }
    inline void openUrlInSelectedTab_protected() { WebView::openUrlInSelectedTab(); }
    QWidget * overlayWidget() override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * event) { WebView::paintEvent(event); }
    void paintEvent(QPaintEvent * event) override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return WebView::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    void requestFullScreen(bool enable) override;
    inline void resizeEvent_protected(QResizeEvent * event) { WebView::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    inline void savePageAs_protected() { WebView::savePageAs(); }
    inline void searchSelectedText_protected() { WebView::searchSelectedText(); }
    inline void searchSelectedTextInBackgroundTab_protected() { WebView::searchSelectedTextInBackgroundTab(); }
    inline void sendTextByMail_protected() { WebView::sendTextByMail(); }
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return WebView::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { WebView::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    inline void showSiteInfo_protected() { WebView::showSiteInfo(); }
    QSize sizeHint() const override;
    inline void slotIconChanged_protected() { WebView::slotIconChanged(); }
    inline void slotLoadFinished_protected(bool ok) { WebView::slotLoadFinished(ok); }
    inline void slotLoadProgress_protected(int progress) { WebView::slotLoadProgress(progress); }
    inline void slotLoadStarted_protected() { WebView::slotLoadStarted(); }
    inline void slotTitleChanged_protected(const QString & title) { WebView::slotTitleChanged(title); }
    inline void slotUrlChanged_protected(const QUrl & url) { WebView::slotUrlChanged(url); }
    inline void tabletEvent_protected(QTabletEvent * event) { WebView::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { WebView::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void userDefinedOpenUrlInBgTab_protected(const QUrl & url = QUrl()) { WebView::userDefinedOpenUrlInBgTab(url); }
    inline void userDefinedOpenUrlInNewTab_protected(const QUrl & url = QUrl(), bool invert = false) { WebView::userDefinedOpenUrlInNewTab(url, invert); }
    inline void wheelEvent_protected(QWheelEvent * event) { WebView::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~WebViewWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[61];
};

#  endif // SBK_WEBVIEWWRAPPER_H

#  ifndef SBK_QWEBENGINEVIEWWRAPPER_H
#  define SBK_QWEBENGINEVIEWWRAPPER_H

// Inherited base class:
class QWebEngineViewWrapper : public QWebEngineView
{
public:
    QWebEngineViewWrapper(QWidget * parent = Q_NULLPTR);
    inline void actionEvent_protected(QActionEvent * event) { QWebEngineView::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void changeEvent_protected(QEvent * event) { QWebEngineView::changeEvent(event); }
    void changeEvent(QEvent * event) override;
    inline void childEvent_protected(QChildEvent * event) { QWebEngineView::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * arg__1) { QWebEngineView::closeEvent(arg__1); }
    void closeEvent(QCloseEvent * arg__1) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QWebEngineView::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * arg__1) { QWebEngineView::contextMenuEvent(arg__1); }
    void contextMenuEvent(QContextMenuEvent * arg__1) override;
    inline void create_protected(WId arg__1 = 0, bool initializeWindow = true, bool destroyOldWindow = true) { QWebEngineView::create(arg__1, initializeWindow, destroyOldWindow); }
    inline QWebEngineView * createWindow_protected(QWebEnginePage::WebWindowType type) { return QWebEngineView::createWindow(QWebEnginePage::WebWindowType(type)); }
    QWebEngineView * createWindow(QWebEnginePage::WebWindowType type) override;
    inline void customEvent_protected(QEvent * event) { QWebEngineView::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void destroy_protected(bool destroyWindow = true, bool destroySubWindows = true) { QWebEngineView::destroy(destroyWindow, destroySubWindows); }
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QWebEngineView::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * e) { QWebEngineView::dragEnterEvent(e); }
    void dragEnterEvent(QDragEnterEvent * e) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * e) { QWebEngineView::dragLeaveEvent(e); }
    void dragLeaveEvent(QDragLeaveEvent * e) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * e) { QWebEngineView::dragMoveEvent(e); }
    void dragMoveEvent(QDragMoveEvent * e) override;
    inline void dropEvent_protected(QDropEvent * e) { QWebEngineView::dropEvent(e); }
    void dropEvent(QDropEvent * e) override;
    inline void enterEvent_protected(QEvent * event) { QWebEngineView::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * arg__1) { return QWebEngineView::event(arg__1); }
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * event) { QWebEngineView::focusInEvent(event); }
    void focusInEvent(QFocusEvent * event) override;
    inline bool focusNextChild_protected() { return QWebEngineView::focusNextChild(); }
    inline bool focusNextPrevChild_protected(bool next) { return QWebEngineView::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * event) { QWebEngineView::focusOutEvent(event); }
    void focusOutEvent(QFocusEvent * event) override;
    inline bool focusPreviousChild_protected() { return QWebEngineView::focusPreviousChild(); }
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * arg__1) { QWebEngineView::hideEvent(arg__1); }
    void hideEvent(QHideEvent * arg__1) override;
    inline void initPainter_protected(QPainter * painter) const { QWebEngineView::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { QWebEngineView::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline void keyPressEvent_protected(QKeyEvent * event) { QWebEngineView::keyPressEvent(event); }
    void keyPressEvent(QKeyEvent * event) override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { QWebEngineView::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { QWebEngineView::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return QWebEngineView::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { QWebEngineView::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * event) { QWebEngineView::mouseMoveEvent(event); }
    void mouseMoveEvent(QMouseEvent * event) override;
    inline void mousePressEvent_protected(QMouseEvent * event) { QWebEngineView::mousePressEvent(event); }
    void mousePressEvent(QMouseEvent * event) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * event) { QWebEngineView::mouseReleaseEvent(event); }
    void mouseReleaseEvent(QMouseEvent * event) override;
    inline void moveEvent_protected(QMoveEvent * event) { QWebEngineView::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return QWebEngineView::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * event) { QWebEngineView::paintEvent(event); }
    void paintEvent(QPaintEvent * event) override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return QWebEngineView::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { QWebEngineView::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return QWebEngineView::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * arg__1) { QWebEngineView::showEvent(arg__1); }
    void showEvent(QShowEvent * arg__1) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { QWebEngineView::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { QWebEngineView::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void updateMicroFocus_protected() { QWebEngineView::updateMicroFocus(); }
    inline void wheelEvent_protected(QWheelEvent * event) { QWebEngineView::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~QWebEngineViewWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[49];
};

#  endif // SBK_QWEBENGINEVIEWWRAPPER_H

#  ifndef SBK_QWIDGETWRAPPER_H
#  define SBK_QWIDGETWRAPPER_H

// Inherited base class:
class QWidgetWrapper : public QWidget
{
public:
    QWidgetWrapper(QWidget * parent = nullptr, QFlags<Qt::WindowType> f = Qt::WindowFlags());
    inline void actionEvent_protected(QActionEvent * event) { QWidget::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void changeEvent_protected(QEvent * event) { QWidget::changeEvent(event); }
    void changeEvent(QEvent * event) override;
    inline void childEvent_protected(QChildEvent * event) { QWidget::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { QWidget::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QWidget::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * event) { QWidget::contextMenuEvent(event); }
    void contextMenuEvent(QContextMenuEvent * event) override;
    inline void create_protected(WId arg__1 = 0, bool initializeWindow = true, bool destroyOldWindow = true) { QWidget::create(arg__1, initializeWindow, destroyOldWindow); }
    inline void customEvent_protected(QEvent * event) { QWidget::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void destroy_protected(bool destroyWindow = true, bool destroySubWindows = true) { QWidget::destroy(destroyWindow, destroySubWindows); }
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QWidget::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * event) { QWidget::dragEnterEvent(event); }
    void dragEnterEvent(QDragEnterEvent * event) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * event) { QWidget::dragLeaveEvent(event); }
    void dragLeaveEvent(QDragLeaveEvent * event) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * event) { QWidget::dragMoveEvent(event); }
    void dragMoveEvent(QDragMoveEvent * event) override;
    inline void dropEvent_protected(QDropEvent * event) { QWidget::dropEvent(event); }
    void dropEvent(QDropEvent * event) override;
    inline void enterEvent_protected(QEvent * event) { QWidget::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * event) { return QWidget::event(event); }
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * event) { QWidget::focusInEvent(event); }
    void focusInEvent(QFocusEvent * event) override;
    inline bool focusNextChild_protected() { return QWidget::focusNextChild(); }
    inline bool focusNextPrevChild_protected(bool next) { return QWidget::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * event) { QWidget::focusOutEvent(event); }
    void focusOutEvent(QFocusEvent * event) override;
    inline bool focusPreviousChild_protected() { return QWidget::focusPreviousChild(); }
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { QWidget::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline void initPainter_protected(QPainter * painter) const { QWidget::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { QWidget::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QWidget::isSignalConnected(signal); }
    inline void keyPressEvent_protected(QKeyEvent * event) { QWidget::keyPressEvent(event); }
    void keyPressEvent(QKeyEvent * event) override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { QWidget::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { QWidget::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return QWidget::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { QWidget::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * event) { QWidget::mouseMoveEvent(event); }
    void mouseMoveEvent(QMouseEvent * event) override;
    inline void mousePressEvent_protected(QMouseEvent * event) { QWidget::mousePressEvent(event); }
    void mousePressEvent(QMouseEvent * event) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * event) { QWidget::mouseReleaseEvent(event); }
    void mouseReleaseEvent(QMouseEvent * event) override;
    inline void moveEvent_protected(QMoveEvent * event) { QWidget::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return QWidget::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * event) { QWidget::paintEvent(event); }
    void paintEvent(QPaintEvent * event) override;
    inline int receivers_protected(const char * signal) const { return QWidget::receivers(signal); }
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return QWidget::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { QWidget::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    inline QObject * sender_protected() const { return QWidget::sender(); }
    inline int senderSignalIndex_protected() const { return QWidget::senderSignalIndex(); }
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return QWidget::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { QWidget::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { QWidget::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { QWidget::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void updateMicroFocus_protected() { QWidget::updateMicroFocus(); }
    inline void wheelEvent_protected(QWheelEvent * event) { QWidget::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~QWidgetWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[48];
};

#  endif // SBK_QWIDGETWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_TABBEDWEBVIEWWRAPPER_H

