#ifndef SBK_TOOLBUTTONWRAPPER_H
#define SBK_TOOLBUTTONWRAPPER_H

#include <toolbutton.h>


// Extra includes
#include <qobject.h>
#include <qwidget.h>
#include <qimage.h>
#include <qicon.h>
#include <qmenu.h>
#include <qevent.h>
#include <qaction.h>
#include <qcoreevent.h>
#include <qsize.h>
#include <qobjectdefs.h>
#include <qpaintdevice.h>
#include <qpoint.h>
#include <qpainter.h>
#include <qbytearray.h>
#include <qstyleoption.h>
namespace PySide { class DynamicQMetaObject; }

class ToolButtonWrapper : public ToolButton
{
public:
    ToolButtonWrapper(QWidget * parent = nullptr);
    inline void actionEvent_protected(QActionEvent * arg__1) { ToolButton::actionEvent(arg__1); }
    void actionEvent(QActionEvent * arg__1) override;
    inline void changeEvent_protected(QEvent * arg__1) { ToolButton::changeEvent(arg__1); }
    void changeEvent(QEvent * arg__1) override;
    inline void checkStateSet_protected() { ToolButton::checkStateSet(); }
    void checkStateSet() override;
    inline void childEvent_protected(QChildEvent * event) { ToolButton::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { ToolButton::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { ToolButton::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * e) { ToolButton::contextMenuEvent(e); }
    void contextMenuEvent(QContextMenuEvent * e) override;
    inline void customEvent_protected(QEvent * event) { ToolButton::customEvent(event); }
    void customEvent(QEvent * event) override;
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { ToolButton::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * event) { ToolButton::dragEnterEvent(event); }
    void dragEnterEvent(QDragEnterEvent * event) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * event) { ToolButton::dragLeaveEvent(event); }
    void dragLeaveEvent(QDragLeaveEvent * event) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * event) { ToolButton::dragMoveEvent(event); }
    void dragMoveEvent(QDragMoveEvent * event) override;
    inline void dropEvent_protected(QDropEvent * event) { ToolButton::dropEvent(event); }
    void dropEvent(QDropEvent * event) override;
    inline void enterEvent_protected(QEvent * arg__1) { ToolButton::enterEvent(arg__1); }
    void enterEvent(QEvent * arg__1) override;
    inline bool event_protected(QEvent * e) { return ToolButton::event(e); }
    bool event(QEvent * e) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * e) { ToolButton::focusInEvent(e); }
    void focusInEvent(QFocusEvent * e) override;
    inline bool focusNextPrevChild_protected(bool next) { return ToolButton::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * e) { ToolButton::focusOutEvent(e); }
    void focusOutEvent(QFocusEvent * e) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { ToolButton::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline bool hitButton_protected(const QPoint & pos) const { return ToolButton::hitButton(pos); }
    bool hitButton(const QPoint & pos) const override;
    inline void initPainter_protected(QPainter * painter) const { ToolButton::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void initStyleOption_protected(QStyleOptionToolButton * option) const { ToolButton::initStyleOption(option); }
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { ToolButton::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline void keyPressEvent_protected(QKeyEvent * e) { ToolButton::keyPressEvent(e); }
    void keyPressEvent(QKeyEvent * e) override;
    inline void keyReleaseEvent_protected(QKeyEvent * e) { ToolButton::keyReleaseEvent(e); }
    void keyReleaseEvent(QKeyEvent * e) override;
    inline void leaveEvent_protected(QEvent * arg__1) { ToolButton::leaveEvent(arg__1); }
    void leaveEvent(QEvent * arg__1) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return ToolButton::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * e) { ToolButton::mouseDoubleClickEvent(e); }
    void mouseDoubleClickEvent(QMouseEvent * e) override;
    inline void mouseMoveEvent_protected(QMouseEvent * e) { ToolButton::mouseMoveEvent(e); }
    void mouseMoveEvent(QMouseEvent * e) override;
    inline void mousePressEvent_protected(QMouseEvent * e) { ToolButton::mousePressEvent(e); }
    void mousePressEvent(QMouseEvent * e) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * e) { ToolButton::mouseReleaseEvent(e); }
    void mouseReleaseEvent(QMouseEvent * e) override;
    inline void moveEvent_protected(QMoveEvent * event) { ToolButton::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return ToolButton::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    inline void nextCheckState_protected() { ToolButton::nextCheckState(); }
    void nextCheckState() override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * e) { ToolButton::paintEvent(e); }
    void paintEvent(QPaintEvent * e) override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return ToolButton::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { ToolButton::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return ToolButton::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { ToolButton::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { ToolButton::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * arg__1) { ToolButton::timerEvent(arg__1); }
    void timerEvent(QTimerEvent * arg__1) override;
    inline void wheelEvent_protected(QWheelEvent * event) { ToolButton::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~ToolButtonWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[51];
};

#  ifndef SBK_QTOOLBUTTONWRAPPER_H
#  define SBK_QTOOLBUTTONWRAPPER_H

// Inherited base class:
class QToolButtonWrapper : public QToolButton
{
public:
    QToolButtonWrapper(QWidget * parent = nullptr);
    inline void actionEvent_protected(QActionEvent * arg__1) { QToolButton::actionEvent(arg__1); }
    void actionEvent(QActionEvent * arg__1) override;
    inline void changeEvent_protected(QEvent * arg__1) { QToolButton::changeEvent(arg__1); }
    void changeEvent(QEvent * arg__1) override;
    inline void checkStateSet_protected() { QToolButton::checkStateSet(); }
    void checkStateSet() override;
    inline void childEvent_protected(QChildEvent * event) { QToolButton::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { QToolButton::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QToolButton::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * event) { QToolButton::contextMenuEvent(event); }
    void contextMenuEvent(QContextMenuEvent * event) override;
    inline void customEvent_protected(QEvent * event) { QToolButton::customEvent(event); }
    void customEvent(QEvent * event) override;
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QToolButton::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * event) { QToolButton::dragEnterEvent(event); }
    void dragEnterEvent(QDragEnterEvent * event) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * event) { QToolButton::dragLeaveEvent(event); }
    void dragLeaveEvent(QDragLeaveEvent * event) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * event) { QToolButton::dragMoveEvent(event); }
    void dragMoveEvent(QDragMoveEvent * event) override;
    inline void dropEvent_protected(QDropEvent * event) { QToolButton::dropEvent(event); }
    void dropEvent(QDropEvent * event) override;
    inline void enterEvent_protected(QEvent * arg__1) { QToolButton::enterEvent(arg__1); }
    void enterEvent(QEvent * arg__1) override;
    inline bool event_protected(QEvent * e) { return QToolButton::event(e); }
    bool event(QEvent * e) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * e) { QToolButton::focusInEvent(e); }
    void focusInEvent(QFocusEvent * e) override;
    inline bool focusNextPrevChild_protected(bool next) { return QToolButton::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * e) { QToolButton::focusOutEvent(e); }
    void focusOutEvent(QFocusEvent * e) override;
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { QToolButton::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline bool hitButton_protected(const QPoint & pos) const { return QToolButton::hitButton(pos); }
    bool hitButton(const QPoint & pos) const override;
    inline void initPainter_protected(QPainter * painter) const { QToolButton::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void initStyleOption_protected(QStyleOptionToolButton * option) const { QToolButton::initStyleOption(option); }
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { QToolButton::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline void keyPressEvent_protected(QKeyEvent * e) { QToolButton::keyPressEvent(e); }
    void keyPressEvent(QKeyEvent * e) override;
    inline void keyReleaseEvent_protected(QKeyEvent * e) { QToolButton::keyReleaseEvent(e); }
    void keyReleaseEvent(QKeyEvent * e) override;
    inline void leaveEvent_protected(QEvent * arg__1) { QToolButton::leaveEvent(arg__1); }
    void leaveEvent(QEvent * arg__1) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return QToolButton::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { QToolButton::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * e) { QToolButton::mouseMoveEvent(e); }
    void mouseMoveEvent(QMouseEvent * e) override;
    inline void mousePressEvent_protected(QMouseEvent * arg__1) { QToolButton::mousePressEvent(arg__1); }
    void mousePressEvent(QMouseEvent * arg__1) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * arg__1) { QToolButton::mouseReleaseEvent(arg__1); }
    void mouseReleaseEvent(QMouseEvent * arg__1) override;
    inline void moveEvent_protected(QMoveEvent * event) { QToolButton::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return QToolButton::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    inline void nextCheckState_protected() { QToolButton::nextCheckState(); }
    void nextCheckState() override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * arg__1) { QToolButton::paintEvent(arg__1); }
    void paintEvent(QPaintEvent * arg__1) override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return QToolButton::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { QToolButton::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return QToolButton::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { QToolButton::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { QToolButton::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * arg__1) { QToolButton::timerEvent(arg__1); }
    void timerEvent(QTimerEvent * arg__1) override;
    inline void wheelEvent_protected(QWheelEvent * event) { QToolButton::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~QToolButtonWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[51];
};

#  endif // SBK_QTOOLBUTTONWRAPPER_H

#  ifndef SBK_QABSTRACTBUTTONWRAPPER_H
#  define SBK_QABSTRACTBUTTONWRAPPER_H

// Inherited base class:
class QAbstractButtonWrapper : public QAbstractButton
{
public:
    QAbstractButtonWrapper(QWidget * parent = nullptr);
    inline void actionEvent_protected(QActionEvent * event) { QAbstractButton::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void changeEvent_protected(QEvent * e) { QAbstractButton::changeEvent(e); }
    void changeEvent(QEvent * e) override;
    inline void checkStateSet_protected() { QAbstractButton::checkStateSet(); }
    void checkStateSet() override;
    inline void childEvent_protected(QChildEvent * event) { QAbstractButton::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { QAbstractButton::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QAbstractButton::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * event) { QAbstractButton::contextMenuEvent(event); }
    void contextMenuEvent(QContextMenuEvent * event) override;
    inline void create_protected(WId arg__1 = 0, bool initializeWindow = true, bool destroyOldWindow = true) { QAbstractButton::create(arg__1, initializeWindow, destroyOldWindow); }
    inline void customEvent_protected(QEvent * event) { QAbstractButton::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void destroy_protected(bool destroyWindow = true, bool destroySubWindows = true) { QAbstractButton::destroy(destroyWindow, destroySubWindows); }
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QAbstractButton::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * event) { QAbstractButton::dragEnterEvent(event); }
    void dragEnterEvent(QDragEnterEvent * event) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * event) { QAbstractButton::dragLeaveEvent(event); }
    void dragLeaveEvent(QDragLeaveEvent * event) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * event) { QAbstractButton::dragMoveEvent(event); }
    void dragMoveEvent(QDragMoveEvent * event) override;
    inline void dropEvent_protected(QDropEvent * event) { QAbstractButton::dropEvent(event); }
    void dropEvent(QDropEvent * event) override;
    inline void enterEvent_protected(QEvent * event) { QAbstractButton::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * e) { return QAbstractButton::event(e); }
    bool event(QEvent * e) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * e) { QAbstractButton::focusInEvent(e); }
    void focusInEvent(QFocusEvent * e) override;
    inline bool focusNextChild_protected() { return QAbstractButton::focusNextChild(); }
    inline bool focusNextPrevChild_protected(bool next) { return QAbstractButton::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * e) { QAbstractButton::focusOutEvent(e); }
    void focusOutEvent(QFocusEvent * e) override;
    inline bool focusPreviousChild_protected() { return QAbstractButton::focusPreviousChild(); }
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { QAbstractButton::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline bool hitButton_protected(const QPoint & pos) const { return QAbstractButton::hitButton(pos); }
    bool hitButton(const QPoint & pos) const override;
    inline void initPainter_protected(QPainter * painter) const { QAbstractButton::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { QAbstractButton::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline void keyPressEvent_protected(QKeyEvent * e) { QAbstractButton::keyPressEvent(e); }
    void keyPressEvent(QKeyEvent * e) override;
    inline void keyReleaseEvent_protected(QKeyEvent * e) { QAbstractButton::keyReleaseEvent(e); }
    void keyReleaseEvent(QKeyEvent * e) override;
    inline void leaveEvent_protected(QEvent * event) { QAbstractButton::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return QAbstractButton::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { QAbstractButton::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * e) { QAbstractButton::mouseMoveEvent(e); }
    void mouseMoveEvent(QMouseEvent * e) override;
    inline void mousePressEvent_protected(QMouseEvent * e) { QAbstractButton::mousePressEvent(e); }
    void mousePressEvent(QMouseEvent * e) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * e) { QAbstractButton::mouseReleaseEvent(e); }
    void mouseReleaseEvent(QMouseEvent * e) override;
    inline void moveEvent_protected(QMoveEvent * event) { QAbstractButton::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return QAbstractButton::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    inline void nextCheckState_protected() { QAbstractButton::nextCheckState(); }
    void nextCheckState() override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * e) { paintEvent(e); }
    void paintEvent(QPaintEvent * e) override;
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return QAbstractButton::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { QAbstractButton::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return QAbstractButton::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { QAbstractButton::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { QAbstractButton::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * e) { QAbstractButton::timerEvent(e); }
    void timerEvent(QTimerEvent * e) override;
    inline void updateMicroFocus_protected() { QAbstractButton::updateMicroFocus(); }
    inline void wheelEvent_protected(QWheelEvent * event) { QAbstractButton::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~QAbstractButtonWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[51];
};

#  endif // SBK_QABSTRACTBUTTONWRAPPER_H

#  ifndef SBK_QWIDGETWRAPPER_H
#  define SBK_QWIDGETWRAPPER_H

// Inherited base class:
class QWidgetWrapper : public QWidget
{
public:
    QWidgetWrapper(QWidget * parent = nullptr, QFlags<Qt::WindowType> f = Qt::WindowFlags());
    inline void actionEvent_protected(QActionEvent * event) { QWidget::actionEvent(event); }
    void actionEvent(QActionEvent * event) override;
    inline void changeEvent_protected(QEvent * event) { QWidget::changeEvent(event); }
    void changeEvent(QEvent * event) override;
    inline void childEvent_protected(QChildEvent * event) { QWidget::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void closeEvent_protected(QCloseEvent * event) { QWidget::closeEvent(event); }
    void closeEvent(QCloseEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QWidget::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void contextMenuEvent_protected(QContextMenuEvent * event) { QWidget::contextMenuEvent(event); }
    void contextMenuEvent(QContextMenuEvent * event) override;
    inline void create_protected(WId arg__1 = 0, bool initializeWindow = true, bool destroyOldWindow = true) { QWidget::create(arg__1, initializeWindow, destroyOldWindow); }
    inline void customEvent_protected(QEvent * event) { QWidget::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void destroy_protected(bool destroyWindow = true, bool destroySubWindows = true) { QWidget::destroy(destroyWindow, destroySubWindows); }
    int devType() const override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QWidget::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    inline void dragEnterEvent_protected(QDragEnterEvent * event) { QWidget::dragEnterEvent(event); }
    void dragEnterEvent(QDragEnterEvent * event) override;
    inline void dragLeaveEvent_protected(QDragLeaveEvent * event) { QWidget::dragLeaveEvent(event); }
    void dragLeaveEvent(QDragLeaveEvent * event) override;
    inline void dragMoveEvent_protected(QDragMoveEvent * event) { QWidget::dragMoveEvent(event); }
    void dragMoveEvent(QDragMoveEvent * event) override;
    inline void dropEvent_protected(QDropEvent * event) { QWidget::dropEvent(event); }
    void dropEvent(QDropEvent * event) override;
    inline void enterEvent_protected(QEvent * event) { QWidget::enterEvent(event); }
    void enterEvent(QEvent * event) override;
    inline bool event_protected(QEvent * event) { return QWidget::event(event); }
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void focusInEvent_protected(QFocusEvent * event) { QWidget::focusInEvent(event); }
    void focusInEvent(QFocusEvent * event) override;
    inline bool focusNextChild_protected() { return QWidget::focusNextChild(); }
    inline bool focusNextPrevChild_protected(bool next) { return QWidget::focusNextPrevChild(next); }
    bool focusNextPrevChild(bool next) override;
    inline void focusOutEvent_protected(QFocusEvent * event) { QWidget::focusOutEvent(event); }
    void focusOutEvent(QFocusEvent * event) override;
    inline bool focusPreviousChild_protected() { return QWidget::focusPreviousChild(); }
    bool hasHeightForWidth() const override;
    int heightForWidth(int arg__1) const override;
    inline void hideEvent_protected(QHideEvent * event) { QWidget::hideEvent(event); }
    void hideEvent(QHideEvent * event) override;
    inline void initPainter_protected(QPainter * painter) const { QWidget::initPainter(painter); }
    void initPainter(QPainter * painter) const override;
    inline void inputMethodEvent_protected(QInputMethodEvent * event) { QWidget::inputMethodEvent(event); }
    void inputMethodEvent(QInputMethodEvent * event) override;
    QVariant inputMethodQuery(Qt::InputMethodQuery arg__1) const override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QWidget::isSignalConnected(signal); }
    inline void keyPressEvent_protected(QKeyEvent * event) { QWidget::keyPressEvent(event); }
    void keyPressEvent(QKeyEvent * event) override;
    inline void keyReleaseEvent_protected(QKeyEvent * event) { QWidget::keyReleaseEvent(event); }
    void keyReleaseEvent(QKeyEvent * event) override;
    inline void leaveEvent_protected(QEvent * event) { QWidget::leaveEvent(event); }
    void leaveEvent(QEvent * event) override;
    const QMetaObject * metaObject() const override;
    inline int metric_protected(QPaintDevice::PaintDeviceMetric arg__1) const { return QWidget::metric(QPaintDevice::PaintDeviceMetric(arg__1)); }
    int metric(QPaintDevice::PaintDeviceMetric arg__1) const override;
    QSize minimumSizeHint() const override;
    inline void mouseDoubleClickEvent_protected(QMouseEvent * event) { QWidget::mouseDoubleClickEvent(event); }
    void mouseDoubleClickEvent(QMouseEvent * event) override;
    inline void mouseMoveEvent_protected(QMouseEvent * event) { QWidget::mouseMoveEvent(event); }
    void mouseMoveEvent(QMouseEvent * event) override;
    inline void mousePressEvent_protected(QMouseEvent * event) { QWidget::mousePressEvent(event); }
    void mousePressEvent(QMouseEvent * event) override;
    inline void mouseReleaseEvent_protected(QMouseEvent * event) { QWidget::mouseReleaseEvent(event); }
    void mouseReleaseEvent(QMouseEvent * event) override;
    inline void moveEvent_protected(QMoveEvent * event) { QWidget::moveEvent(event); }
    void moveEvent(QMoveEvent * event) override;
    inline bool nativeEvent_protected(const QByteArray & eventType, void * message, long * result) { return QWidget::nativeEvent(eventType, message, result); }
    bool nativeEvent(const QByteArray & eventType, void * message, long * result) override;
    QPaintEngine * paintEngine() const override;
    inline void paintEvent_protected(QPaintEvent * event) { QWidget::paintEvent(event); }
    void paintEvent(QPaintEvent * event) override;
    inline int receivers_protected(const char * signal) const { return QWidget::receivers(signal); }
    inline QPaintDevice * redirected_protected(QPoint * offset) const { return QWidget::redirected(offset); }
    QPaintDevice * redirected(QPoint * offset) const override;
    inline void resizeEvent_protected(QResizeEvent * event) { QWidget::resizeEvent(event); }
    void resizeEvent(QResizeEvent * event) override;
    inline QObject * sender_protected() const { return QWidget::sender(); }
    inline int senderSignalIndex_protected() const { return QWidget::senderSignalIndex(); }
    void setVisible(bool visible) override;
    inline QPainter * sharedPainter_protected() const { return QWidget::sharedPainter(); }
    QPainter * sharedPainter() const override;
    inline void showEvent_protected(QShowEvent * event) { QWidget::showEvent(event); }
    void showEvent(QShowEvent * event) override;
    QSize sizeHint() const override;
    inline void tabletEvent_protected(QTabletEvent * event) { QWidget::tabletEvent(event); }
    void tabletEvent(QTabletEvent * event) override;
    inline void timerEvent_protected(QTimerEvent * event) { QWidget::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    inline void updateMicroFocus_protected() { QWidget::updateMicroFocus(); }
    inline void wheelEvent_protected(QWheelEvent * event) { QWidget::wheelEvent(event); }
    void wheelEvent(QWheelEvent * event) override;
    ~QWidgetWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[48];
};

#  endif // SBK_QWIDGETWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_TOOLBUTTONWRAPPER_H

