#ifndef SBK_WEBPAGEWRAPPER_H
#define SBK_WEBPAGEWRAPPER_H

#include <webpage.h>


// Extra includes
#include <qobject.h>
#include <webview.h>
#include <qpoint.h>
#include <webhittestresult.h>
#include <qurl.h>
#include <qwebenginefullscreenrequest.h>
#include <qwebenginecertificateerror.h>
#include <qwebenginepage.h>
#include <qsize.h>
#include <qcoreevent.h>
#include <qwebenginecontextmenudata.h>
#include <qrect.h>
#include <qicon.h>
#include <qcolor.h>
#include <qbytearray.h>
#include <qobjectdefs.h>
#include <qwebenginehttprequest.h>
#include <qmenu.h>
#include <qaction.h>
#include <qpagelayout.h>
#include <qwidget.h>
namespace PySide { class DynamicQMetaObject; }

class WebPageWrapper : public WebPage
{
public:
    WebPageWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { WebPage::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { WebPage::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { WebPage::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { WebPage::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline void finished_protected() { WebPage::finished(); }
    void javaScriptAlert(const QUrl & securityOrigin, const QString & msg) override;
    bool javaScriptConfirm(const QUrl & securityOrigin, const QString & msg) override;
    void javaScriptConsoleMessage(QWebEnginePage::JavaScriptConsoleMessageLevel level, const QString & message, int lineNumber, const QString & sourceID) override;
    inline bool javaScriptPrompt_protected(const QUrl & securityOrigin, const QString & msg, const QString & defaultValue, QString * result) { return WebPage::javaScriptPrompt(securityOrigin, msg, defaultValue, result); }
    bool javaScriptPrompt(const QUrl & securityOrigin, const QString & msg, const QString & defaultValue, QString * result) override;
    const QMetaObject * metaObject() const override;
    inline void progress_protected(int prog) { WebPage::progress(prog); }
    inline void timerEvent_protected(QTimerEvent * event) { WebPage::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    void triggerAction(QWebEnginePage::WebAction action, bool checked = false) override;
    ~WebPageWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[17];
};

#  ifndef SBK_QWEBENGINEPAGEWRAPPER_H
#  define SBK_QWEBENGINEPAGEWRAPPER_H

// Inherited base class:
class QWebEnginePageWrapper : public QWebEnginePage
{
public:
    QWebEnginePageWrapper(QObject * parent = Q_NULLPTR);
    QWebEnginePageWrapper(QWebEngineProfile * profile, QObject * parent = Q_NULLPTR);
    inline bool acceptNavigationRequest_protected(const QUrl & url, QWebEnginePage::NavigationType type, bool isMainFrame) { return QWebEnginePage::acceptNavigationRequest(url, QWebEnginePage::NavigationType(type), isMainFrame); }
    bool acceptNavigationRequest(const QUrl & url, QWebEnginePage::NavigationType type, bool isMainFrame) override;
    inline bool certificateError_protected(const QWebEngineCertificateError & certificateError) { return QWebEnginePage::certificateError(certificateError); }
    bool certificateError(const QWebEngineCertificateError & certificateError) override;
    inline void childEvent_protected(QChildEvent * event) { QWebEnginePage::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline QStringList chooseFiles_protected(QWebEnginePage::FileSelectionMode mode, const QStringList & oldFiles, const QStringList & acceptedMimeTypes) { return QWebEnginePage::chooseFiles(QWebEnginePage::FileSelectionMode(mode), oldFiles, acceptedMimeTypes); }
    QStringList chooseFiles(QWebEnginePage::FileSelectionMode mode, const QStringList & oldFiles, const QStringList & acceptedMimeTypes) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QWebEnginePage::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline QWebEnginePage * createWindow_protected(QWebEnginePage::WebWindowType type) { return QWebEnginePage::createWindow(QWebEnginePage::WebWindowType(type)); }
    QWebEnginePage * createWindow(QWebEnginePage::WebWindowType type) override;
    inline void customEvent_protected(QEvent * event) { QWebEnginePage::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QWebEnginePage::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * arg__1) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QWebEnginePage::isSignalConnected(signal); }
    inline void javaScriptAlert_protected(const QUrl & securityOrigin, const QString & msg) { QWebEnginePage::javaScriptAlert(securityOrigin, msg); }
    void javaScriptAlert(const QUrl & securityOrigin, const QString & msg) override;
    inline bool javaScriptConfirm_protected(const QUrl & securityOrigin, const QString & msg) { return QWebEnginePage::javaScriptConfirm(securityOrigin, msg); }
    bool javaScriptConfirm(const QUrl & securityOrigin, const QString & msg) override;
    inline void javaScriptConsoleMessage_protected(QWebEnginePage::JavaScriptConsoleMessageLevel level, const QString & message, int lineNumber, const QString & sourceID) { QWebEnginePage::javaScriptConsoleMessage(QWebEnginePage::JavaScriptConsoleMessageLevel(level), message, lineNumber, sourceID); }
    void javaScriptConsoleMessage(QWebEnginePage::JavaScriptConsoleMessageLevel level, const QString & message, int lineNumber, const QString & sourceID) override;
    inline bool javaScriptPrompt_protected(const QUrl & securityOrigin, const QString & msg, const QString & defaultValue, QString * result) { return QWebEnginePage::javaScriptPrompt(securityOrigin, msg, defaultValue, result); }
    bool javaScriptPrompt(const QUrl & securityOrigin, const QString & msg, const QString & defaultValue, QString * result) override;
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QWebEnginePage::receivers(signal); }
    inline QObject * sender_protected() const { return QWebEnginePage::sender(); }
    inline int senderSignalIndex_protected() const { return QWebEnginePage::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QWebEnginePage::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    void triggerAction(QWebEnginePage::WebAction action, bool checked = false) override;
    ~QWebEnginePageWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[17];
};

#  endif // SBK_QWEBENGINEPAGEWRAPPER_H

#  ifndef SBK_QOBJECTWRAPPER_H
#  define SBK_QOBJECTWRAPPER_H

// Inherited base class:
class QObjectWrapper : public QObject
{
public:
    QObjectWrapper(QObject * parent = nullptr);
    inline void childEvent_protected(QChildEvent * event) { QObject::childEvent(event); }
    void childEvent(QChildEvent * event) override;
    inline void connectNotify_protected(const QMetaMethod & signal) { QObject::connectNotify(signal); }
    void connectNotify(const QMetaMethod & signal) override;
    inline void customEvent_protected(QEvent * event) { QObject::customEvent(event); }
    void customEvent(QEvent * event) override;
    inline void disconnectNotify_protected(const QMetaMethod & signal) { QObject::disconnectNotify(signal); }
    void disconnectNotify(const QMetaMethod & signal) override;
    bool event(QEvent * event) override;
    bool eventFilter(QObject * watched, QEvent * event) override;
    inline bool isSignalConnected_protected(const QMetaMethod & signal) const { return QObject::isSignalConnected(signal); }
    const QMetaObject * metaObject() const override;
    inline int receivers_protected(const char * signal) const { return QObject::receivers(signal); }
    inline QObject * sender_protected() const { return QObject::sender(); }
    inline int senderSignalIndex_protected() const { return QObject::senderSignalIndex(); }
    inline void timerEvent_protected(QTimerEvent * event) { QObject::timerEvent(event); }
    void timerEvent(QTimerEvent * event) override;
    ~QObjectWrapper();
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[8];
};

#  endif // SBK_QOBJECTWRAPPER_H

#endif // SBK_WEBPAGEWRAPPER_H

